      subroutine etotal(energia)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
#ifndef ISNAN
      external proc_proc
#ifdef WINPGI
cMS$ATTRIBUTES C ::  proc_proc
#endif
#endif
#if defined(MPI) && defined(FINEGRAIN)
      include "mpif.h"
      double precision weights_(max_ene)
#endif
      include 'COMMON.SETUP'
      include 'COMMON.IOUNITS'
      double precision energia(0:max_ene)
      include 'COMMON.LOCAL'
      include 'COMMON.FFIELD'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.SBRIDGE'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.CONTROL'
      include 'COMMON.TIME1'
      include 'COMMON.CONTACTS'
#if defined(MPI) && defined(FINEGRAIN)
c      print*,"ETOTAL Processor",fg_rank," absolute rank",myrank,
c     & " nfgtasks",nfgtasks
      if (nfgtasks.gt.1) then
        time00=MPI_Wtime()
C FG slaves call the following matching MPI_Bcast in ERGASTULUM
        if (fg_rank.eq.0) then
          call MPI_Bcast(0,1,MPI_INTEGER,king,FG_COMM,IERROR)
c          print *,"Processor",myrank," BROADCAST iorder"
C FG master sets up the WEIGHTS_ array which will be broadcast to the 
C FG slaves as WEIGHTS array.
          weights_(1)=wvdwpp
          weights_(2)=welpp
          weights_(3)=wvdwpsb
          weights_(4)=welpsb
          weights_(5)=wvdwsb
          weights_(6)=welsb
          weights_(7)=wbond
          weights_(8)=wang
          weights_(9)=wsbloc
          weights_(10)=wtor
          weights_(11)=wtor_d
          weights_(12)=wcorr
          weights_(13)=wcorr3
          weights_(14)=wstrain
          weights_(15)=wdihc
          weights_(16)=scal14
C FG Master broadcasts the WEIGHTS_ array
          call MPI_Bcast(weights_(1),n_ene,
     &        MPI_DOUBLE_PRECISION,king,FG_COMM,IERROR)
        else
C FG slaves receive the WEIGHTS array
          call MPI_Bcast(weights(1),n_ene,
     &        MPI_DOUBLE_PRECISION,king,FG_COMM,IERROR)
          wvdwpp =weights(1)
          welpp  =weights(2)
          wwdwpsb=weights(3)
          welpsb =weights(4)
          wvdwsb =weights(5)
          welsb  =weights(6)
          wbond  =weights(7)
          wang   =weights(8)
          wsbloc =weights(9)
          wtor   =weights(10)
          wtor_d =weights(11)
          wcorr  =weights(12)
          wcorr3 =weights(13)
          wstrain=weights(14)
          wdihc=weights(15)
          scal14 =weights(16)
        endif
        time_Bcast=time_Bcast+MPI_Wtime()-time00
        time_Bcastw=time_Bcastw+MPI_Wtime()-time00
c        call chainbuild_cart
      endif
c      print *,'Processor',myrank,' calling etotal ipot=',ipot
c      print *,'Processor',myrank,' nnt=',nnt,' nct=',nct
#else
c      if (modecalc.eq.12.or.modecalc.eq.14) then
c        call int_from_cart1(.false.)
c      endif
#endif     
#if defined(MPI) && defined(FINEGRAIN)
      time00=MPI_Wtime()
#endif
C 
C Compute the sugarbase-sugarbase interaction energy
C
      goto (101,102,103) ipot
C Lennard-Jones potential.
  101 call esb_lj(evdwsb,eelsb)
cd    print '(a)','Exit ELJ'
      goto 107
C Gay-Berne potential (shifted LJ, angular dependence).
  102 call esb_gb(evdwsb,eelsb)
      goto 107
C Soft-sphere potential
  103 call esb_softsphere(evdwsb,eelsb)
C
C Calculate electrostatic (H-bonding) energy of the main chain.
C
  107 continue
#if defined(MPI) && defined(FINEGRAIN)
      time01=MPI_Wtime() 
#endif
c      print *,"Processor",myrank," left VEC_AND_DERIV"
      if (ipot.lt.6) then
C Base-pairing - base-stacking correlation energy
        if (wcorr.gt.0.0d0 .or. wcorr3.gt.0d0) then
          call multibody_hb(ecorr,ecorr3,n_corr,n_corr1)
c          write (iout,*) "multibody_hb ecorr",ecorr," n_corr",n_corr,
c     &      " n_corr1",n_corr1
        endif
C Phosphate-phosphate interaction energy
        if (wvdwpp.gt.0.0d0 .or. welpp.gt.0.0d0) then
          call epp(evdwpp,eespp)
        else
          evdwpp=0.0d0
          eespp=0.0d0
        endif
C Phosphate-sugarbase interaction energy
        if (wvdwpsb.gt.0.0d0 .or. welpsb.gt.0.0d0) then
           call epsb(evdwpsb,eespsb)
        else
          evdwpsb=0.0d0
          eespsb=0.0d0
        endif
      else
C Phosphate-phosphate interaction energy
        call epp_softsphere(evdwpp,eespp)
C Phosphate-sugarbase interaction energy
        call epsb_softsphere(evdwpsb,eespsb)
      endif
c
c Calculate the bond-stretching energy
c
      call ebond(estr)
C 
C Calculate the disulfide-bridge and other energy and the contributions
C from other distance constraints.
      call edis(ehpb)
C
C Calculate the virtual-bond-angle energy.
C
      call ebend(ebe)
C
C Calculate the sugarbase local energy.
C
      call esb(esbloc)
C
C Calculate the virtual-bond torsional energy.
C
      call etor(etors,edihcnstr)
#ifdef DOUBLETOR
C
C 6/23/01 Calculate double-torsional energy
C
      call etor_d(etors_d)
#endif
C 
C If performing constraint dynamics, call the constraint energy
C  after the equilibration time
      Uconst=0.0d0
      Uconst_back=0.0d0
#if defined(MPI) && defined(FINEGRAIN)
      time_enecalc=time_enecalc+MPI_Wtime()-time00
c      print *,"Processor",myrank," computed Uconstr"
      time00=MPI_Wtime()
#endif
c
C Sum the energies
C
      energia(1)=evdwpp
      energia(2)=eespp
      energia(3)=evdwpsb
      energia(4)=eelpsb
      energia(5)=evdwsb
      energia(6)=eelsb
      energia(7)=estr
      energia(8)=ebe
      energia(9)=esbloc
      energia(10)=etors
      energia(11)=etors_d
      energia(12)=ecorr 
      energia(13)=ecorr3
      energia(14)=ehpb
      energia(15)=edihcnstr
c      print *," Processor",myrank," calls SUM_ENERGY"
      call sum_energy(energia,.true.)
c      print *," Processor",myrank," left SUM_ENERGY"
#if defined(MPI) && defined(FINEGRAIN)
      time_sumene=time_sumene+MPI_Wtime()-time00
#endif
      return
      end
c-------------------------------------------------------------------------------
      subroutine sum_energy(energia,reduce)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
#ifndef ISNAN
      external proc_proc
#ifdef WINPGI
cMS$ATTRIBUTES C ::  proc_proc
#endif
#endif
#if defined(MPI) && defined(FINEGRAIN)
      include "mpif.h"
#endif
      include 'COMMON.SETUP'
      include 'COMMON.IOUNITS'
      double precision energia(0:max_ene),enebuff(0:max_ene+1)
      include 'COMMON.FFIELD'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.SBRIDGE'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.CONTROL'
      include 'COMMON.TIME1'
      logical reduce
#if defined(MPI) && defined(FINEGRAIN)
      if (nfgtasks.gt.1 .and. reduce) then
#ifdef DEBUG
        write (iout,*) "energies before REDUCE"
        call enerprint(energia)
        call flush(iout)
#endif
        do i=0,n_ene
          enebuff(i)=energia(i)
        enddo
        time00=MPI_Wtime()
        call MPI_Barrier(FG_COMM,IERR)
        time_barrier_e=time_barrier_e+MPI_Wtime()-time00
        time00=MPI_Wtime()
        call MPI_Reduce(enebuff(0),energia(0),n_ene+1,
     &    MPI_DOUBLE_PRECISION,MPI_SUM,king,FG_COMM,IERR)
#ifdef DEBUG
        write (iout,*) "energies after REDUCE"
        call enerprint(energia)
        call flush(iout)
#endif
        time_Reduce=time_Reduce+MPI_Wtime()-time00
      endif
      if (fg_rank.eq.0) then
#endif
      evdwpp=   energia(1)
      eelpp=    energia(2)
      evdwpsb=  energia(3)
      eelpsb=   energia(4)
      evdwsb=   energia(5)
      eelsb=    energia(6)
      estr=     energia(7) 
      ebe=      energia(8)
      esbloc=   energia(9)
      etors=    energia(10)
      etors_d=  energia(11)
      ecorr=    energia(12)
      ecorr3=   energia(13)
      ehpb=     energia(14)
      edihcnstr=energia(15)
      Uconst=   energia(16)
      etot=wvdwpp*evdwpp+welpp*eelpp+wvdwpsb*evdwpsb+welpsb*epsb
     & +wvdwsb*evdwsb+welsb*eelsb+wbond*estr
     & +wang*ebe+wsbloc*esbloc+wtor*etors+wtor_d*etors_d
     & +wcorr*ecorr+wcorr3*ecorr3+wstrain*ehpb+edihcnstr+Uconst
      energia(0)=etot
c      write (2,*) "energy",wvdwpp*evdwpp,welpp*eelpp,wvdwpsb*evdwpsb,welpsb*epsb
c     & ,wvdwsb*evdwsb,welsb*eelsb,wbond*estr
c     & ,wang*ebe,wsbloc*esbloc,wtor*etors,wtor_d*etors_d
c     & ,wcorr*ecorr,wcorr3*ecorr3,wstrain*ehpb,edihcnstr,Uconst
c detecting NaNQ
#ifdef ISNAN
#ifdef AIX
      if (isnan(etot).ne.0) energia(0)=1.0d+99
#else
      if (isnan(etot)) energia(0)=1.0d+99
#endif
#else
      i=0
#ifdef WINPGI
      idumm=proc_proc(etot,i)
#else
      call proc_proc(etot,i)
#endif
      if(i.eq.1)energia(0)=1.0d+99
#endif
#if defined(MPI) && defined(FINEGRAIN)
      endif
#endif
      return
      end
c-------------------------------------------------------------------------------
      subroutine sum_gradient
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
#ifndef ISNAN
      external proc_proc
#ifdef WINPGI
cMS$ATTRIBUTES C ::  proc_proc
#endif
#endif
#if defined(MPI) && defined(FINEGRAIN)
      include 'mpif.h'
#endif
      double precision gradbufc(3,maxres),gradbufx(3,maxres),
     &  glocbuf(4*maxres),gradbufc_sum(3,maxres)
      include 'COMMON.SETUP'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.SBRIDGE'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.CONTROL'
      include 'COMMON.TIME1'
#if defined(MPI) && defined(FINEGRAIN)
C FG slaves call the following matching MPI_Bcast in ERGASTULUM
        if (nfgtasks.gt.1 .and. fg_rank.eq.0) 
     &    call MPI_Bcast(1,1,MPI_INTEGER,king,FG_COMM,IERROR)
#endif
C
C 9/29/08 AL Transform parts of gradients in site coordinates to the gradient
C            in virtual-bond-vector coordinates
C
c      write (2,*) "SUM_GRADIENT"
c      write (2,*) "wvdwpp",wvdwpp," welpp",welpp," wvdwpsb",wvdwpsb,
c     &   " wvdwsb",wvdwsb," welsb",welsb
      do i=1,nct
        do j=1,3
          gradbufc(j,i)=wvdwpp*gvdwpp(j,i)+welpp*gelpp(j,i)+
     &                wvdwpsb*(gvdwpsb(j,i)+gvdwpsb1(j,i))+
     &                wvdwsb*gvdwsbc(j,i)+welsb*gelsbc(j,i)+
     &                wcorr*gradcorr(j,i)+wcorr3*gradcorr3(j,i)+
     &                wstrain*ghpbc(j,i)
        enddo
      enddo 
#if defined(MPI) && defined(FINEGRAIN)
      if (nfgtasks.gt.1) then
      time00=MPI_Wtime()
#ifdef DEBUG
      write (iout,*) "gradbufc before allreduce"
      do i=1,nres
        write (iout,'(i3,3f10.5)') i,(gradbufc(j,i),j=1,3)
      enddo
      call flush(iout)
#endif
      do i=1,nres
        do j=1,3
          gradbufc_sum(j,i)=gradbufc(j,i)
        enddo
      enddo
#ifdef TIMING
c      time_allreduce=time_allreduce+MPI_Wtime()-time00
#endif
      do i=nnt,nres
        do k=1,3
          gradbufc(k,i)=0.0d0
        enddo
      enddo
#ifdef DEBUG
      write (iout,*) "igrad_start",igrad_start," igrad_end",igrad_end
      write (iout,*) (i," jgrad_start",jgrad_start(i),
     &                  " jgrad_end  ",jgrad_end(i),
     &                  i=igrad_start,igrad_end)
#endif
      do j=1,3
        gradbufc(j,nres-1)=gradbufc_sum(j,nres)
      enddo
      do i=nres-2,nnt,-1
        do j=1,3
          gradbufc(j,i)=gradbufc(j,i+1)+gradbufc_sum(j,i+1)
        enddo
      enddo
#ifdef DEBUG
      write (iout,*) "gradbufc after summing"
      do i=1,nres
        write (iout,'(i3,3f10.5)') i,(gradbufc(j,i),j=1,3)
      enddo
      call flush(iout)
#endif
      else
#endif
#ifdef DEBUG
      write (iout,*) "gradbufc"
      do i=1,nres
        write (iout,'(i3,3f10.5)') i,(gradbufc(j,i),j=1,3)
      enddo
      call flush(iout)
#endif
      do i=1,nres
        do j=1,3
          gradbufc_sum(j,i)=gradbufc(j,i)
          gradbufc(j,i)=0.0d0
        enddo
      enddo
      do j=1,3
        gradbufc(j,nres-1)=gradbufc_sum(j,nres)
      enddo
      do i=nres-2,nnt,-1
        do j=1,3
          gradbufc(j,i)=gradbufc(j,i+1)+gradbufc_sum(j,i+1)
        enddo
      enddo
#ifdef DEBUG
      write (iout,*) "gradbufc after summing"
      do i=1,nres
        write (iout,'(i3,3f10.5)') i,(gradbufc(j,i),j=1,3)
      enddo
      call flush(iout)
#endif
#if defined(MPI) && defined(FINEGRAIN)
      endif
#endif
      do k=1,3
        gradbufc(k,nres)=0.0d0
      enddo
      do i=1,nct
        do j=1,3
          gradc(j,i,icg)=gradbufc(j,i)+
     &                0.5d0*(wvdwpp*gvdwpp(j,i)+welpp*gelpp(j,i)+
     &                 wvdwpsb*gvdwpsb1(j,i))+
     &                wbond*gradb(j,i)+wsbloc*gsbloc(j,i)
          gradx(j,i,icg)=wvdwsb*gvdwsbx(j,i)+welsb*gelsbx(j,i)+
     &                  wbond*gradbx(j,i)+wstrain*ghpbx(j,i)+
     &                  wcorr*gradxorr(j,i)+wcorr3*gradcorr3(j,i)+
     &                  wsbloc*gsblocx(j,i)
        enddo
      enddo 
#ifdef DEBUG
      write (iout,*) "gloc before adding corr"
      do i=1,4*nres
        write (iout,*) i,gloc(i,icg)
      enddo
#endif
#ifdef DEBUG
      write (iout,*) "gloc after adding corr"
      do i=1,4*nres
        write (iout,*) i,gloc(i,icg)
      enddo
#endif
#if defined(MPI) && defined(FINEGRAIN)
      if (nfgtasks.gt.1) then
        do j=1,3
          do i=1,nres
            gradbufc(j,i)=gradc(j,i,icg)
            gradbufx(j,i)=gradx(j,i,icg)
          enddo
        enddo
        do i=1,4*nres
          glocbuf(i)=gloc(i,icg)
        enddo
        time00=MPI_Wtime()
        call MPI_Barrier(FG_COMM,IERR)
        time_barrier_g=time_barrier_g+MPI_Wtime()-time00
        time00=MPI_Wtime()
        call MPI_Reduce(gradbufc(1,1),gradc(1,1,icg),3*nres,
     &    MPI_DOUBLE_PRECISION,MPI_SUM,king,FG_COMM,IERR)
        call MPI_Reduce(gradbufx(1,1),gradx(1,1,icg),3*nres,
     &    MPI_DOUBLE_PRECISION,MPI_SUM,king,FG_COMM,IERR)
        call MPI_Reduce(glocbuf(1),gloc(1,icg),4*nres,
     &    MPI_DOUBLE_PRECISION,MPI_SUM,king,FG_COMM,IERR)
        time_reduce=time_reduce+MPI_Wtime()-time00
#ifdef DEBUG
      write (iout,*) "gloc after reduce"
      do i=1,4*nres
        write (iout,*) i,gloc(i,icg)
      enddo
#endif
      endif
#endif
#ifdef DEBUG
      write (iout,*) "gradc gradx gloc"
      do i=1,nres
        write (iout,'(i5,3f10.5,5x,3f10.5,5x,f10.5)') 
     &   i,(gradc(j,i,icg),j=1,3),(gradx(j,i,icg),j=1,3),gloc(i,icg)
      enddo 
#endif
      return
      end
c-------------------------------------------------------------------------------
      subroutine rescale_weights(t_bath)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.SBRIDGE'
      double precision kfac /2.4d0/
      double precision x,x2,x3,x4,x5,licznik /1.12692801104297249644/
c      facT=temp0/t_bath
c      facT=2*temp0/(t_bath+temp0)
      if (rescale_mode.eq.0) then
        facT=1.0d0
        facT2=1.0d0
        facT3=1.0d0
        facT4=1.0d0
        facT5=1.0d0
      else if (rescale_mode.eq.1) then
        facT=kfac/(kfac-1.0d0+t_bath/temp0)
        facT2=kfac**2/(kfac**2-1.0d0+(t_bath/temp0)**2)
        facT3=kfac**3/(kfac**3-1.0d0+(t_bath/temp0)**3)
        facT4=kfac**4/(kfac**4-1.0d0+(t_bath/temp0)**4)
        facT5=kfac**5/(kfac**5-1.0d0+(t_bath/temp0)**5)
      else if (rescale_mode.eq.2) then
        x=t_bath/temp0
        x2=x*x
        x3=x2*x
        x4=x3*x
        x5=x4*x
        facT=licznik/dlog(dexp(x)+dexp(-x))
        facT2=licznik/dlog(dexp(x2)+dexp(-x2))
        facT3=licznik/dlog(dexp(x3)+dexp(-x3))
        facT4=licznik/dlog(dexp(x4)+dexp(-x4))
        facT5=licznik/dlog(dexp(x5)+dexp(-x5))
      else
        write (iout,*) "Wrong RESCALE_MODE",rescale_mode
        write (*,*) "Wrong RESCALE_MODE",rescale_mode
#if defined(MPI) && defined(FINEGRAIN)
       call MPI_Finalize(MPI_COMM_WORLD,IERROR)
#endif
       stop 555
      endif
      welsb= weights(6)*fact
      welpsb=weights(4)*fact
      wcorr= weights(12)*fact3
      wcorr3=weights(13)*fact2
      wtor=  weights(10)*fact
      wtor_d=weights(11)*fact2

      return
      end
C------------------------------------------------------------------------
      subroutine enerprint(energia)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.SBRIDGE'
      include 'COMMON.NAMES'
      double precision energia(0:max_ene),w(max_ene)
      character*28 fullname(16) /
     &  "(phosphate-phosphate VDW)","(phosphate-phosphate elec)",
     &  "(phosphate-sugarbase VDW)","(phosphate-sugarbase elec)",
     &  "(sugarbase-sugarbase VDW)","(sugarbase-sugarbase elec)",
     &  "(virtual-bond stretching)","(virtual-bond-angle bending)",
     &  "(sugarbase rotamer)","(torsional)","(double torsional)",
     &  "(multibody 4th order)","(multibody 3rd order)",
     &  "(distance constraints)",
     &  "(dihedral angle constraints)","(q constraints)"/
      w(1)=wvdwpp
      w(2)=welpp
      w(3)=wvdwpsb
      w(4)=welpsb
      w(5)=wvdwsb
      w(6)=welsb
      w(7)=wbond
      w(8)=wang
      w(9)=wsbloc
      w(10)=wtor
      w(11)=wtor_d
      w(12)=wcorr
      w(13)=wcorr3
      w(14)=wstrain
      write (iout,10) (ename(i),energia(i),w(i),fullname(i),i=1,13)
      write (iout,20) (ename(i),energia(i),fullname(i),i=14,15),
     & "ETOT    ",energia(0),"(total)                                 "
      write (iout,*) 
   10 format (/'Virtual-chain energies:'//
     &  13(/a8,1h=,1pE16.6,' WEIGHT=',1pe16.6,1x,a28))
   20 format (a8,1h=,1pE16.6,1x,a28)
      return
      end
C-----------------------------------------------------------------------
      subroutine esb_lj(evdwsb,eelsb)
C
C This subroutine calculates the interaction energy of nonbonded side chains
C assuming the LJ potential of interaction.
C
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      parameter (accur=1.0d-10)
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.TORSION'
      include 'COMMON.SBRIDGE'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.CONTACTS'
      include 'COMMON.CALC'
      evdwsb=0.0D0
      eelsb=0.0d0
      do i=iatsc_s,iatsc_e
        itypi=itype(i)
        if (itypi.eq.ntyp1) cycle
        itypi1=itype(i+1)
        xi=c(1,nres+i)
        yi=c(2,nres+i)
        zi=c(3,nres+i)
        num_conti=0
C
C Calculate SC interaction energy.
C
        do iint=1,nint_gr(i)
          do j=istart(i,iint),iend(i,iint)
            itypj=itype(j)
            if (itypj.eq.ntyp1) cycle
c            write(2,*)"ij",i,j," itypi",itypi," itypj",itypj
            xj=c(1,nres+j)-xi
            yj=c(2,nres+j)-yi
            zj=c(3,nres+j)-zi
c            write(2,*)"coords",(c(k,nres+i),k=1,3),(c(k,nres+j),k=1,3)
c            write(2,*)"xj",xj," yj",yj," zj",zj
C Change 12/1/95 to calculate four-body interactions
            rij=xj*xj+yj*yj+zj*zj
            rrij=1.0D0/rij
c            write (2,*) "rij",rij," rrij",rrij
            eps0ij=eps(itypi,itypj)
c            write (2,*)"expon2",expon2," fac",fac
            fac=rrij**expon2
            e1=fac*fac*aa(itypi,itypj)
            e2=fac*bb(itypi,itypj)
            evdwij=e1+e2
            evdwsb=evdwsb+evdwij
C 
C Calculate the components of the gradient in DC and X
C
            fac=-rrij*(e1+evdwij)
            gg(1)=xj*fac
            gg(2)=yj*fac
            gg(3)=zj*fac
            do k=1,3
              gvdwsbx(k,i)=gvdwsbx(k,i)-gg(k)
              gvdwsbx(k,j)=gvdwsbx(k,j)+gg(k)
              gvdwsbc(k,i)=gvdwsbc(k,i)-gg(k)
              gvdwsbc(k,j)=gvdwsbc(k,j)+gg(k)
            enddo
            rij=dsqrt(rrij)
            erij(1)=xj*rij
            erij(2)=yj*rij
            erij(3)=zj*rij
            om1=dxi*erij(1)+dyi*erij(2)+dzi*erij(3)
            om2=dxj*erij(1)+dyj*erij(2)+dzj*erij(3)
            om12=dxi*dxj+dyi*dyj+dzi*dzj
c            write (iout,*) "ELJ: i,j,rij,rrij",i,j,rij,rrij,
c     &       " evdwij",evdwij
            call eelsbij(eelij,num_conti)
            eelsb=eelsb+eelij
          enddo      ! j
        enddo        ! iint
        num_cont_hb(i)=num_conti
      enddo          ! i
      do i=1,nct
        do j=1,3
          gvdwsbc(j,i)=expon*gvdwsbc(j,i)
          gvdwsbx(j,i)=expon*gvdwsbx(j,i)
        enddo
      enddo
C******************************************************************************
C
C                              N O T E !!!
C
C To save time, the factor of EXPON has been extracted from ALL components
C of GVDWC and GRADX. Remember to multiply them by this factor before further 
C use!
C
C******************************************************************************
      return
      end
C-----------------------------------------------------------------------------
      subroutine esb_gb(evdwsb,eelsb)
C
C This subroutine calculates the interaction energy between sugarbase sites
C assuming the Gay-Berne potential of VDW interactions.
C
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.NAMES'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.CALC'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      logical lprn
      evdw=0.0D0
      eelsb=0.0d0
      ecorr=0.0d0
ccccc      energy_dec=.false.
      lprn=.false.
      if (lprn) write(2,*)
     & 'Entering EGB nnt=',nnt,' nct=',nct,' expon=',expon
      evdwsb=0.0D0
c     if (icall.eq.0) lprn=.false.
      ind=0
      do i=iatsc_s,iatsc_e
        num_conti=0
        itypi=itype(i)
        if (itypi.eq.ntyp1) cycle
        itypi1=itype(i+1)
        xi=c(1,nres+i)
        yi=c(2,nres+i)
        zi=c(3,nres+i)
        dxi=dc_norm(1,nres+i)
        dyi=dc_norm(2,nres+i)
        dzi=dc_norm(3,nres+i)
        dsci_inv=vbld_inv(i+nres)
C
C Calculate SC interaction energy.
C
        do iint=1,nint_gr(i)
          do j=istart(i,iint),iend(i,iint)
            ind=ind+1
            itypj=itype(j)
            if (itypj.eq.ntyp1) cycle
            dscj_inv=vbld_inv(j+nres)
            sig0ij=sigma(itypi,itypj)
            chi1=chi(itypi,itypj)
            chi2=chi(itypj,itypi)
            chi12=chi1*chi2
            chip1=chip(itypi,itypj)
            chip2=chip(itypj,itypi)
            chip12=chip1*chip2
            xj=c(1,nres+j)-xi
            yj=c(2,nres+j)-yi
            zj=c(3,nres+j)-zi
            dxj=dc_norm(1,nres+j)
            dyj=dc_norm(2,nres+j)
            dzj=dc_norm(3,nres+j)
            rrij=1.0D0/(xj*xj+yj*yj+zj*zj)
            rij=dsqrt(rrij)
C Calculate angle-dependent terms of energy and contributions to their
C derivatives.
            erij(1)=xj*rij
            erij(2)=yj*rij
            erij(3)=zj*rij
            om1=dxi*erij(1)+dyi*erij(2)+dzi*erij(3)
            om2=dxj*erij(1)+dyj*erij(2)+dzj*erij(3)
            om12=dxi*dxj+dyi*dyj+dzi*dzj
            call sc_angular
            sigsq=1.0D0/sigsq
            sig=sig0ij*dsqrt(sigsq)
            rij_shift=1.0D0/rij-sig+sig0ij
c            write (2,*) " rij",1.0D0/rij," sig",sig," sig0ij",sig0ij,
c     &       " rij_shift",rij_shift
            if (rij_shift.le.0.0D0) then
              evdw=1.0D20
              return
            endif
            sigder=-sig*sigsq
c---------------------------------------------------------------
            rij_shift=1.0D0/rij_shift 
            fac=rij_shift**expon
            e1=fac*fac*aa(itypi,itypj)
            e2=fac*bb(itypi,itypj)
            evdwij=eps1*eps2rt*(e1+e2)
c            write (2,*) "eps1",eps1," eps2rt",eps2rt,
c     &       " e1",e1," e2",e2," evdwij",evdwij
            eps2der=evdwij
            evdwij=evdwij*eps2rt
            evdwsb=evdwsb+evdwij
            if (lprn) then
            sigm=dabs(aa(itypi,itypj)/bb(itypi,itypj))**(1.0D0/6.0D0)
            epsi=bb(itypi,itypj)**2/aa(itypi,itypj)
            write (iout,'(2(a3,i3,2x),17(0pf7.3))')
     &        restyp(itypi),i,restyp(itypj),j,
     &        epsi,sigm,chi1,chi2,chip1,chip2,
     &        eps1,eps2rt**2,sig,sig0ij,
     &        om1,om2,om12,1.0D0/rij,1.0D0/rij_shift,
     &        evdwij
            write (iout,*) "aa",aa(itypi,itypj)," bb",bb(itypi,itypj)
            endif

            if (energy_dec) write (iout,'(a6,2i5,0pf7.3)') 
     &                        'evdw',i,j,evdwij

C Calculate gradient components.
            e1=e1*eps1*eps2rt**2
            fac=-expon*(e1+evdwij)*rij_shift
            sigder=fac*sigder
            fac=rij*fac
c            fac=0.0d0
C Calculate the radial part of the gradient
            gg(1)=xj*fac
            gg(2)=yj*fac
            gg(3)=zj*fac
C Calculate angular part of the gradient.
            call sc_grad
            call eelsbij(eelij,num_conti)
            eelsb=eelsb+eelij
          enddo      ! j
        enddo        ! iint
        num_cont_hb(i)=num_conti
      enddo          ! i
c      write (iout,*) "Number of loop steps in EGB:",ind
cccc      energy_dec=.false.
      return
      end
C-----------------------------------------------------------------------------
      subroutine sc_angular
C Calculate eps1,eps2,eps3,sigma, and parts of their derivatives in om1,om2,
C om12. Called by ebp, egb, and egbv.
      implicit none
      include 'COMMON.CALC'
      include 'COMMON.IOUNITS'
c      erij(1)=xj*rij
c      erij(2)=yj*rij
c      erij(3)=zj*rij
c      om1=dxi*erij(1)+dyi*erij(2)+dzi*erij(3)
c      om2=dxj*erij(1)+dyj*erij(2)+dzj*erij(3)
c      om12=dxi*dxj+dyi*dyj+dzi*dzj
      chiom12=chi12*om12
C Calculate eps1(om12) and its derivative in om12
      faceps1=1.0D0-om12*chiom12
      faceps1_inv=1.0D0/faceps1
      eps1=dsqrt(faceps1_inv)
C Following variable is eps1*deps1/dom12
      eps1_om12=faceps1_inv*chiom12
C Calculate sigma(om1,om2,om12) and the derivatives of sigma**2 in om1,om2,
C and om12.
      om1om2=om1*om2
      chiom1=chi1*om1
      chiom2=chi2*om2
      facsig=om1*chiom1+om2*chiom2-2.0D0*om1om2*chiom12
      sigsq=1.0D0-facsig*faceps1_inv
      sigsq_om1=(chiom1-chiom12*om2)*faceps1_inv
      sigsq_om2=(chiom2-chiom12*om1)*faceps1_inv
      sigsq_om12=-chi12*(om1om2*faceps1-om12*facsig)*faceps1_inv**2
C Calculate eps2 and its derivatives in om1, om2, and om12.
      chipom1=chip1*om1
      chipom2=chip2*om2
      chipom12=chip12*om12
      facp=1.0D0-om12*chipom12
      facp_inv=1.0D0/facp
      facp1=om1*chipom1+om2*chipom2-2.0D0*om1om2*chipom12
C Following variable is the square root of eps2
      eps2rt=1.0D0-facp1*facp_inv
C Following three variables are the derivatives of the square root of eps
C in om1, om2, and om12.
      eps2rt_om1=-4.0D0*(chipom1-chipom12*om2)*facp_inv
      eps2rt_om2=-4.0D0*(chipom2-chipom12*om1)*facp_inv
      eps2rt_om12=4.0D0*chip12*(om1om2*facp-om12*facp1)*facp_inv**2 
      return
      end
C----------------------------------------------------------------------------
      subroutine sc_grad
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.CALC'
      include 'COMMON.IOUNITS'
      double precision dcosom1(3),dcosom2(3)
      eom1=eps2der*eps2rt_om1+sigder*sigsq_om1
      eom2=eps2der*eps2rt_om2+sigder*sigsq_om2
      eom12=evdwij*eps1_om12+eps2der*eps2rt_om12+sigder*sigsq_om12
      do k=1,3
        dcosom1(k)=rij*(dc_norm(k,nres+i)-om1*erij(k))
        dcosom2(k)=rij*(dc_norm(k,nres+j)-om2*erij(k))
      enddo
      do k=1,3
        gg(k)=gg(k)+eom1*dcosom1(k)+eom2*dcosom2(k)
      enddo 
      do k=1,3
        gvdwsbx(k,i)=gvdwsbx(k,i)-gg(k)
     &            +(eom12*(dc_norm(k,nres+j)-om12*dc_norm(k,nres+i))
     &            +eom1*(erij(k)-om1*dc_norm(k,nres+i)))*dsci_inv
        gvdwsbx(k,j)=gvdwsbx(k,j)+gg(k)
     &            +(eom12*(dc_norm(k,nres+i)-om12*dc_norm(k,nres+j))
     &            +eom2*(erij(k)-om2*dc_norm(k,nres+j)))*dscj_inv
      enddo
C 
C Calculate the components of the gradient in DC and X
C
      do l=1,3
        gvdwsbc(l,i)=gvdwsbc(l,i)-gg(l)
        gvdwsbc(l,j)=gvdwsbc(l,j)+gg(l)
      enddo
      return
      end
C-----------------------------------------------------------------------
      subroutine esb_softsphere(evdw,eel,ecorr)
C
C This subroutine calculates the interaction energy of nonbonded side chains
C assuming the LJ potential of interaction.
C
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      parameter (accur=1.0d-10)
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.TORSION'
      include 'COMMON.SBRIDGE'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.CONTACTS'
      dimension gg(3)
      evdw=0.0D0
      eel=0.0d0
      ecorr=0.0d0
      do i=iatsc_s,iatsc_e
        itypi=itype(i)
        if (itypi.eq.ntyp1) cycle
        itypi1=itype(i+1)
        xi=c(1,nres+i)
        yi=c(2,nres+i)
        zi=c(3,nres+i)
C
C Calculate SC interaction energy.
C
        do iint=1,nint_gr(i)
          do j=istart(i,iint),iend(i,iint)
            itypj=itype(j)
            if (itypj.eq.ntyp1) cycle
            xj=c(1,nres+j)-xi
            yj=c(2,nres+j)-yi
            zj=c(3,nres+j)-zi
            rij=xj*xj+yj*yj+zj*zj
            r0ij=r0(itypi,itypj)
            r0ijsq=r0ij*r0ij
            if (rij.lt.r0ijsq) then
              evdwij=0.25d0*(rij-r0ijsq)**2
              fac=rij-r0ijsq
            else
              evdwij=0.0d0
              fac=0.0d0
            endif
            evdw=evdw+evdwij
C 
C Calculate the components of the gradient in DC and X
C
            gg(1)=xj*fac
            gg(2)=yj*fac
            gg(3)=zj*fac
            do k=1,3
              gvdwsbx(k,i)=gvdwsbx(k,i)-gg(k)
              gvdwsbx(k,j)=gvdwsbx(k,j)+gg(k)
              gvdwsbc(k,i)=gvdwsbc(k,i)-gg(k)
              gvdwsbc(k,j)=gvdwsbc(k,j)+gg(k)
            enddo
          enddo ! j
        enddo ! iint
      enddo ! i
      return
      end
C-----------------------------------------------------------------------
      subroutine eelsbij(eesij,num_conti)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
#if defined(MPI) && defined(FINEGRAIN)
      include "mpif.h"
#endif
      include 'COMMON.CONTROL'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      include 'COMMON.TORSION'
      include 'COMMON.VECTORS'
      include 'COMMON.FFIELD'
      include 'COMMON.TIME1'
      include 'COMMON.CALC'
      dimension ggg(3),gggp(3),gggm(3),dcosb(3),dcosg(3),
     &          erder(3,3),uryg(3,3),urzg(3,3),vryg(3,3),vrzg(3,3)
c 4/26/02 - AL scaling factor for 1,4 repulsive VDW interactions
      double precision scal_el /0.5d0/
      ind=ind+1
      itypi=itype(i)
      itypj=itype(j)
      ael6i=ael6(itypi,itypj)
      ael3i=ael3(itypi,itypj) 
      ael63i=ael63(itypi,itypj) 
      ael32i=ael32(itypi,itypj) 
c      write (iout,*) "eelecij",i,j,itype(i),itype(j),
c     &  ael6i,ael3i,ael63i,al32i,rij,rrij
      dxj=dc(1,j+nres)
      dyj=dc(2,j+nres)
      dzj=dc(3,j+nres)
      dx_normi=dc_norm(1,i+nres)
      dy_normi=dc_norm(2,i+nres)
      dz_normi=dc_norm(3,i+nres)
      dx_normj=dc_norm(1,j+nres)
      dy_normj=dc_norm(2,j+nres)
      dz_normj=dc_norm(3,j+nres)
c      xj=c(1,j)+0.5D0*dxj-xmedi
c      yj=c(2,j)+0.5D0*dyj-ymedi
c      zj=c(3,j)+0.5D0*dzj-zmedi
c      rij=xj*xj+yj*yj+zj*zj
c      rrmij=1.0D0/rij
c      rij=dsqrt(rij)
c      rmij=1.0D0/rij
c      r3ij=rrmij*rmij
c      r6ij=r3ij*r3ij  
      if (ipot.ne.2) then
        cosa=dx_normi*dx_normj+dy_normi*dy_normj+dz_normi*dz_normj
        cosb=(xj*dx_normi+yj*dy_normi+zj*dz_normi)*rmij
        cosg=(xj*dx_normj+yj*dy_normj+zj*dz_normj)*rmij
      else
        cosa=om12
        cosb=om1
        cosg=om2
      endif
      r3ij=rij*rrij
      r6ij=r3ij*r3ij 
      fac=cosa-3.0D0*cosb*cosg
      facfac=fac*fac
      fac1=3.0d0*(cosb*cosb+cosg*cosg)
      fac3=ael6i*r6ij
      fac4=ael3i*r3ij
      fac5=ael63i*r6ij
      fac6=ael32i*r6ij
c      write (iout,*) "r3ij",r3ij," r6ij",r6ij," fac",fac," fac1",fac1,
c     &  " fac2",fac2," fac3",fac3," fac4",fac4," fac5",fac5," fac6",fac6
      el1=fac3*(4.0D0+facfac-fac1)
      el2=fac4*fac       
      el3=fac5*(2.0d0-2.0d0*facfac+fac1)
      el4=fac6*facfac
      eesij=el1+el2+el3+el4
C 12/26/95 - for the evaluation of multi-body H-bonding interactions
      ees0ij=4.0D0+facfac-fac1

      if (energy_dec) then 
          write (iout,'(a6,2i5,e15.3)') 'ees',i,j,eesij
      endif

C
C Calculate contributions to the Cartesian gradient.
C
      facel=-3.0d0*rrij*(eesij+el1+el3+el4)
      fac1=fac
c      erij(1)=xj*rmij
c      erij(2)=yj*rmij
c      erij(3)=zj*rmij
*
* Radial derivatives. First process both termini of the fragment (i,j)
*
      ggg(1)=facel*xj
      ggg(2)=facel*yj
      ggg(3)=facel*zj
c 9/28/08 AL Gradient compotents will be summed only at the end
      do k=1,3
        gelsbc(k,j)=gelsbc(k,j)+ggg(k)
        gelsbc(k,i)=gelsbc(k,i)-ggg(k)
        gelsbx(k,j)=gelsbx(k,j)+ggg(k)
        gelsbx(k,i)=gelsbx(k,i)-ggg(k)
      enddo
*
* Angular part
*          
      ecosa=2.0D0*fac3*fac1+fac4+(-4.0d0*fac5+2.0d0*fac6)*fac1
      fac4=-3.0D0*fac4
      fac3=-6.0D0*fac3
      fac5= 6.0d0*fac5
      fac6=-6.0d0*fac6
      ecosb=fac3*(fac1*cosg+cosb)+cosg*fac4+(cosb+2*fac1*cosg)*fac5+
     & fac6*fac1*cosg
      ecosg=fac3*(fac1*cosb+cosg)+cosb*fac4+(cosg+2*fac1*cosb)*fac5+
     & fac6*fac1*cosb
      do k=1,3
        dcosb(k)=rij*(dc_norm(k,i+nres)-erij(k)*cosb)
        dcosg(k)=rij*(dc_norm(k,j+nres)-erij(k)*cosg)
      enddo
      do k=1,3
        ggg(k)=ecosb*dcosb(k)+ecosg*dcosg(k) 
      enddo
      do k=1,3
        gelsbx(k,i)=gelsbx(k,i)-ggg(k)
     &        +(ecosa*(dc_norm(k,j+nres)-cosa*dc_norm(k,i+nres))
     &        + ecosb*(erij(k)-cosb*dc_norm(k,i+nres)))*vbld_inv(i+nres)
        gelsbx(k,j)=gelsbx(k,j)+ggg(k)
     &        +(ecosa*(dc_norm(k,i+nres)-cosa*dc_norm(k,j+nres))
     &        + ecosg*(erij(k)-cosg*dc_norm(k,j+nres)))*vbld_inv(j+nres)
        gelsbc(k,j)=gelsbc(k,j)+ggg(k)
        gelsbc(k,i)=gelsbc(k,i)-ggg(k)
      enddo
      IF ( (wcorr.gt.0.0d0.or.wcorr3.gt.0.0d0) .and. 
     &     num_conti.le.maxconts) THEN
C
C Calculate the contact function. The ith column of the array JCONT will 
C contain the numbers of atoms that make contacts with the atom I (of numbers
C greater than I). The arrays FACONT and GACONT will contain the values of
C the contact function and its derivative.
        r0ij=2.20D0*sigma(itypi,itypj)
c        write (2,*) "ij",i,j," rij",1.0d0/rij," r0ij",r0ij
        call gcont(rij,r0ij,1.0D0,0.2d0/r0ij,fcont,fprimcont)
c        write (2,*) "fcont",fcont
        if (fcont.gt.0.0D0) then
          num_conti=num_conti+1
          if (num_conti.gt.maxconts) then
            write (iout,*) 'WARNING - max. # of contacts exceeded;',
     &                     ' will skip next contacts for this conf.'
          else
            jcont_hb(num_conti,i)=j
c            write (iout,*) "num_conti",num_conti,
c     &        " jcont_hb",jcont_hb(num_conti,i)
C Calculate contact energies
            cosa4=4.0D0*cosa
            wij=cosa-3.0D0*cosb*cosg
            cosbg1=cosb+cosg
            cosbg2=cosb-cosg
            fac3=dsqrt(-ael6i)*r3ij
c            write (2,*) "ael6i",ael6i," r3ij",r3ij," fac3",fac3
            ees0tmp=4.0D0+cosa4+wij*wij-3.0D0*cosbg1*cosbg1
            if (ees0tmp.gt.0) then
              ees0pij=dsqrt(ees0tmp)
            else
              ees0pij=0
            endif
            ees0tmp=4.0D0-cosa4+wij*wij-3.0D0*cosbg2*cosbg2
            if (ees0tmp.gt.0) then
              ees0mij=dsqrt(ees0tmp)
            else
              ees0mij=0
            endif
c            write (iout,*) "i",i," j",j," fcont",fcont,
c     &         " ees0m",ees0mij," ees0p",ees0pij
            ees0p(num_conti,i)=0.5D0*fac3*(ees0pij+ees0mij)
            ees0m(num_conti,i)=0.5D0*fac3*(ees0pij-ees0mij)
c            write (iout,*) "i",i," j",j,
c     &         " ees0m",ees0m(num_conti,i)," ees0p",ees0p(num_conti,i)
            ees0pij1=fac3/ees0pij 
            ees0mij1=fac3/ees0mij
            fac3p=-3.0D0*fac3*rrij
            ees0pijp=0.5D0*fac3p*(ees0pij+ees0mij)
            ees0mijp=0.5D0*fac3p*(ees0pij-ees0mij)
            ecosa1=       ees0pij1*( 1.0D0+0.5D0*wij)
            ecosb1=-1.5D0*ees0pij1*(wij*cosg+cosbg1)
            ecosg1=-1.5D0*ees0pij1*(wij*cosb+cosbg1)
            ecosa2=       ees0mij1*(-1.0D0+0.5D0*wij)
            ecosb2=-1.5D0*ees0mij1*(wij*cosg+cosbg2) 
            ecosg2=-1.5D0*ees0mij1*(wij*cosb-cosbg2)
            ecosap=ecosa1+ecosa2
            ecosbp=ecosb1+ecosb2
            ecosgp=ecosg1+ecosg2
            ecosam=ecosa1-ecosa2
            ecosbm=ecosb1-ecosb2
            ecosgm=ecosg1-ecosg2
C End diagnostics
            facont_hb(num_conti,i)=fcont
            fprimcont=fprimcont/rij
C Following line is for diagnostics.
c            do k=1,3
c              dcosb(k)=rij*(dc_norm(k,i)-erij(k)*cosb)
c              dcosg(k)=rij*(dc_norm(k,j)-erij(k)*cosg)
c            enddo
            do k=1,3
              gggp(k)=ecosbp*dcosb(k)+ecosgp*dcosg(k)
              gggm(k)=ecosbm*dcosb(k)+ecosgm*dcosg(k)
            enddo
            gggp(1)=gggp(1)+ees0pijp*xj
            gggp(2)=gggp(2)+ees0pijp*yj
            gggp(3)=gggp(3)+ees0pijp*zj
            gggm(1)=gggm(1)+ees0mijp*xj
            gggm(2)=gggm(2)+ees0mijp*yj
            gggm(3)=gggm(3)+ees0mijp*zj
C Derivatives due to the contact function
            gacont_hbr(1,num_conti,i)=fprimcont*xj
            gacont_hbr(2,num_conti,i)=fprimcont*yj
            gacont_hbr(3,num_conti,i)=fprimcont*zj
            do k=1,3
c
c Gradient of the correlation terms
c
              gacontp_hb1(k,num_conti,i)=
     &        (ecosap*(dc_norm(k,j+nres)-cosa*dc_norm(k,i+nres))
     &       + ecosbp*(erij(k)-cosb*dc_norm(k,i+nres)))*vbld_inv(i+nres)
              gacontp_hb2(k,num_conti,i)=
     &        (ecosap*(dc_norm(k,i+nres)-cosa*dc_norm(k,j+nres))
     &       + ecosgp*(erij(k)-cosg*dc_norm(k,j+nres)))*vbld_inv(j+nres)
              gacontp_hb3(k,num_conti,i)=gggp(k)
              gacontm_hb1(k,num_conti,i)=
     &        (ecosam*(dc_norm(k,j+nres)-cosa*dc_norm(k,i+nres))
     &       + ecosbm*(erij(k)-cosb*dc_norm(k,i+nres)))*vbld_inv(i+nres)
              gacontm_hb2(k,num_conti,i)=
     &        (ecosam*(dc_norm(k,i+nres)-cosa*dc_norm(k,j+nres))
     &       + ecosgm*(erij(k)-cosg*dc_norm(k,j+nres)))*vbld_inv(j+nres)
              gacontm_hb3(k,num_conti,i)=gggm(k)
            enddo
          endif
        endif
      ENDIF
      return
      end
C--------------------------------------------------------------------------
      subroutine epp_softsphere(evdw1,ees)
C
C Soft-sphere potential of phosphate-phosphate interaction
C 
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.CONTROL'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      include 'COMMON.TORSION'
      include 'COMMON.VECTORS'
      include 'COMMON.FFIELD'
      dimension ggg(3)
      ees=0.0D0
      evdw1=0.0D0
      ind=0
      do i=iatel_s,iatel_e
        if (itype(i).eq.ntyp1 .or. itype(i+1).eq.ntyp1) cycle
        dxi=dc(1,i)
        dyi=dc(2,i)
        dzi=dc(3,i)
        xmedi=c(1,i)+0.5d0*dxi
        ymedi=c(2,i)+0.5d0*dyi
        zmedi=c(3,i)+0.5d0*dzi
        do j=ielstart(i),ielend(i)
          if (itype(j).eq.ntyp1 .or. itype(j+1).eq.ntyp1) cycle
          ind=ind+1
          r0ij=r0pp
          r0ijsq=r0ij*r0ij 
          dxj=dc(1,j)
          dyj=dc(2,j)
          dzj=dc(3,j)
          xj=c(1,j)+0.5D0*dxj-xmedi
          yj=c(2,j)+0.5D0*dyj-ymedi
          zj=c(3,j)+0.5D0*dzj-zmedi
          rij=xj*xj+yj*yj+zj*zj
          if (rij.lt.r0ijsq) then
            evdw1ij=0.25d0*(rij-r0ijsq)**2
            fac=rij-r0ijsq
          else
            evdw1ij=0.0d0
            fac=0.0d0
          endif
          evdw1=evdw1+evdw1ij
C
C Calculate contributions to the Cartesian gradient.
C
          ggg(1)=fac*xj
          ggg(2)=fac*yj
          ggg(3)=fac*zj
          do k=1,3
            gvdwpp(k,i)=gvdwpp(k,i)-ggg(k)
            gvdwpp(k,j)=gvdwpp(k,j)+ggg(k)
          enddo
        enddo ! j
      enddo   ! i
      return
      end
C--------------------------------------------------------------------------
      subroutine epp(evdw1,ees)
C
C This subroutine calculates the average interaction energy and its gradient
C in the virtual-bond vectors between non-adjacent peptide groups, based on 
C the potential described in Liwo et al., Protein Sci., 1993, 2, 1715. 
C The potential depends both on the distance of peptide-group centers and on 
C the orientation of the CA-CA virtual bonds.
C 
      implicit real*8 (a-h,o-z)
#if defined(MPI) && defined(FINEGRAIN)
      include 'mpif.h'
#endif
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.CONTROL'
      include 'COMMON.SETUP'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      include 'COMMON.TORSION'
      include 'COMMON.VECTORS'
      include 'COMMON.FFIELD'
      include 'COMMON.TIME1'
      dimension ggg(3),gggp(3),gggm(3),erij(3)
c 4/26/02 - AL scaling factor for 1,4 repulsive VDW interactions
      double precision scal_el /0.5d0/
      t_eelecij=0.0d0
      ees=0.0D0
      evdw1=0.0D0
      ind=0
c
c Loop over all pairs of interacting peptide groups except i,i+2 and i,i+3
c
      do i=iatel_s,iatel_e
        if (itype(i).eq.ntyp1 .or. itype(i+1).eq.ntyp1) cycle
        dxi=dc(1,i)
        dyi=dc(2,i)
        dzi=dc(3,i)
        dx_normi=dc_norm(1,i)
        dy_normi=dc_norm(2,i)
        dz_normi=dc_norm(3,i)
        xmedi=c(1,i)+0.5d0*dxi
        ymedi=c(2,i)+0.5d0*dyi
        zmedi=c(3,i)+0.5d0*dzi
        do j=ielstart(i),ielend(i)
          if (itype(i).eq.ntyp1 .or. itype(i+1).eq.ntyp1) cycle
          ind=ind+1
          dxj=dc(1,j)
          dyj=dc(2,j)
          dzj=dc(3,j)
          xj=c(1,j)+0.5D0*dxj-xmedi
          yj=c(2,j)+0.5D0*dyj-ymedi
          zj=c(3,j)+0.5D0*dzj-zmedi
          rij=xj*xj+yj*yj+zj*zj
c          write (2,*)"ij",i,j," r0pp",r0pp," rij",rij," epspp",epspp
          fac=(r0pp**2/rij)**3
          ev1=epspp*fac*fac
          ev2=epspp*fac
          evdw1ij=ev1-2*ev2
          fac=(-ev1-evdw1ij)/rij
c          write (2,*)"fac",fac," ev1",ev1," ev2",ev2," evdw1ij",evdw1ij
          evdw1=evdw1+evdw1ij
C
C Calculate contributions to the Cartesian gradient.
C
          ggg(1)=fac*xj
          ggg(2)=fac*yj
          ggg(3)=fac*zj
          do k=1,3
            gvdwpp(k,i)=gvdwpp(k,i)-ggg(k)
            gvdwpp(k,j)=gvdwpp(k,j)+ggg(k)
          enddo
c phoshate-phosphate electrostatic interactions
          rij=dsqrt(rij)
          fac=1.0d0/rij
          eesij=dexp(-BEES*rij)*fac
c          write (2,*)"fac",fac," eesij",eesij
          ees=ees+eesij
c          fac=-eesij*fac
          fac=-(fac+BEES)*eesij*fac
C
C Calculate contributions to the Cartesian gradient.
C
          ggg(1)=fac*xj
          ggg(2)=fac*yj
          ggg(3)=fac*zj
c          write(2,*) "ggg",i,j,ggg(1),ggg(2),ggg(3)
c          write(2,*) "gelpp",i,(gelpp(k,i),k=1,3)
c          write(2,*) "gelpp",j,(gelpp(k,j),k=1,3)
          do k=1,3
            gelpp(k,i)=gelpp(k,i)-ggg(k)
            gelpp(k,j)=gelpp(k,j)+ggg(k)
          enddo
        enddo ! j
      enddo   ! i
c      ees=332.0d0*ees 
      ees=AEES*ees 
      do i=nnt,nct
c        write (2,*) "i",i," gelpp",(gelpp(k,i),k=1,3)
        do k=1,3
          gvdwpp(k,i)=6*gvdwpp(k,i)
c          gelpp(k,i)=332.0d0*gelpp(k,i)
          gelpp(k,i)=AEES*gelpp(k,i)
        enddo
c        write (2,*) "i",i," gelpp",(gelpp(k,i),k=1,3)
      enddo
c      write (2,*) "total EES",ees
      return
      end
C-----------------------------------------------------------------------------
      subroutine vecpr(u,v,w)
      implicit real*8(a-h,o-z)
      dimension u(3),v(3),w(3)
      w(1)=u(2)*v(3)-u(3)*v(2)
      w(2)=-u(1)*v(3)+u(3)*v(1)
      w(3)=u(1)*v(2)-u(2)*v(1)
      return
      end
C-----------------------------------------------------------------------------
      subroutine unormderiv(u,ugrad,unorm,ungrad)
C This subroutine computes the derivatives of a normalized vector u, given
C the derivatives computed without normalization conditions, ugrad. Returns
C ungrad.
      implicit none
      double precision u(3),ugrad(3,3),unorm,ungrad(3,3)
      double precision vec(3)
      double precision scalar
      integer i,j
c      write (2,*) 'ugrad',ugrad
c      write (2,*) 'u',u
      do i=1,3
        vec(i)=scalar(ugrad(1,i),u(1))
      enddo
c      write (2,*) 'vec',vec
      do i=1,3
        do j=1,3
          ungrad(j,i)=(ugrad(j,i)-u(j)*vec(i))*unorm
        enddo
      enddo
c      write (2,*) 'ungrad',ungrad
      return
      end
C-----------------------------------------------------------------------------
      subroutine epsb_softsphere(evdw2)
C
C This subroutine calculates the excluded-volume interaction energy between
C peptide-group centers and side chains and its gradient in virtual-bond and
C side-chain vectors.
C
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.FFIELD'
      include 'COMMON.IOUNITS'
      include 'COMMON.CONTROL'
      dimension ggg(3)
      evdw2=0.0D0
      r0_scp=4.5d0
cd    print '(a)','Enter ESCP'
cd    write (iout,*) 'iatscp_s=',iatscp_s,' iatscp_e=',iatscp_e
      do i=iatscp_s,iatscp_e
        if (itype(i).eq.ntyp1 .or. itype(i+1).eq.ntyp1) cycle
        xi=0.5D0*(c(1,i)+c(1,i+1))
        yi=0.5D0*(c(2,i)+c(2,i+1))
        zi=0.5D0*(c(3,i)+c(3,i+1))

        do iint=1,nscp_gr(i)

        do j=iscpstart(i,iint),iscpend(i,iint)
          itypj=itype(j)
          if (itypj.eq.ntyp1) cycle
          xj=c(1,j)-xi
          yj=c(2,j)-yi
          zj=c(3,j)-zi
          rij=xj*xj+yj*yj+zj*zj
          r0ij=r0_scp
          r0ijsq=r0ij*r0ij
          if (rij.lt.r0ijsq) then
            evdwij=0.25d0*(rij-r0ijsq)**2
            fac=rij-r0ijsq
          else
            evdwij=0.0d0
            fac=0.0d0
          endif 
          evdw2=evdw2+evdwij
C
C Calculate contributions to the gradient in the virtual-bond and SC vectors.
C
          ggg(1)=xj*fac
          ggg(2)=yj*fac
          ggg(3)=zj*fac
          do k=1,3
            gvdwpsb1(k,i)=gvdwpsb1(k,i)-ggg(k)
            gvdwpsb(k,j)=gvdwpsb(k,j)+ggg(k)
          enddo
        enddo

        enddo ! iint
      enddo ! i
      return
      end
C-----------------------------------------------------------------------------
      subroutine epsb(evdwpsb,eelpsb)
C
C This subroutine calculates the excluded-volume interaction energy between
C peptide-group centers and side chains and its gradient in virtual-bond and
C side-chain vectors.
C
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.FFIELD'
      include 'COMMON.IOUNITS'
      include 'COMMON.CONTROL'
      dimension ggg(3)
c      write(iout, '(a)')'Enter ESCP'
c      write (iout,*) 'iatscp_s=',iatscp_s,' iatscp_e=',iatscp_e
c      write (iout,*) "scal14",scal14
      eelpsb=0.0d0
      evdwpsb=0.0d0
      do i=iatscp_s,iatscp_e
        if (itype(i).eq.ntyp1 .or. itype(i+1).eq.ntyp1) cycle
        xi=0.5D0*(c(1,i)+c(1,i+1))
        yi=0.5D0*(c(2,i)+c(2,i+1))
        zi=0.5D0*(c(3,i)+c(3,i+1))

        do iint=1,nscp_gr(i)

        do j=iscpstart(i,iint),iscpend(i,iint)
          itypj=itype(j)
          if (itypj.eq.ntyp1) cycle
C Uncomment following three lines for SC-p interactions
c         xj=c(1,nres+j)-xi
c         yj=c(2,nres+j)-yi
c         zj=c(3,nres+j)-zi
C Uncomment following three lines for Ca-p interactions
          xj=c(1,j)-xi
          yj=c(2,j)-yi
          zj=c(3,j)-zi
          rrij=1.0D0/(xj*xj+yj*yj+zj*zj)
          fac=rrij**expon2
          e1=fac*fac*aad(itypj)
          e2=fac*bad(itypj)
          if (iabs(j-i) .le. 2) then
            e1=scal14*e1
            e2=scal14*e2
          endif
          evdwij=e1+e2
c          write (2,*) "ij",i,j," itypj",itypj," rrij",rrij,
c     &     " aad",aad(itypj)," bad",bad(itypj)," evdwij",evdwij
          evdwpsb=evdwpsb+evdwij
          if (energy_dec) write (iout,'(a6,2i5,0pf7.3)')
     &        'evdw2',i,j,evdwij
C
C Calculate contributions to the gradient in the virtual-bond and SC vectors.
C
          fac=-(evdwij+e1)*rrij
          ggg(1)=xj*fac
          ggg(2)=yj*fac
          ggg(3)=zj*fac
cgrad          if (j.lt.i) then
cd          write (iout,*) 'j<i'
C Uncomment following three lines for SC-p interactions
c           do k=1,3
c             gradx_scp(k,j)=gradx_scp(k,j)+ggg(k)
c           enddo
cgrad          else
cd          write (iout,*) 'j>i'
cgrad            do k=1,3
cgrad              ggg(k)=-ggg(k)
C Uncomment following line for SC-p interactions
ccgrad             gradx_scp(k,j)=gradx_scp(k,j)-ggg(k)
c             gradx_scp(k,j)=gradx_scp(k,j)+ggg(k)
cgrad            enddo
cgrad          endif
cgrad          do k=1,3
cgrad            gvdwc_scp(k,i)=gvdwc_scp(k,i)-0.5D0*ggg(k)
cgrad          enddo
cgrad          kstart=min0(i+1,j)
cgrad          kend=max0(i-1,j-1)
cd        write (iout,*) 'i=',i,' j=',j,' kstart=',kstart,' kend=',kend
cd        write (iout,*) ggg(1),ggg(2),ggg(3)
cgrad          do k=kstart,kend
cgrad            do l=1,3
cgrad              gvdwc_scp(l,k)=gvdwc_scp(l,k)-ggg(l)
cgrad            enddo
cgrad          enddo
          do k=1,3
            gvdwpsb1(k,i)=gvdwpsb1(k,i)-ggg(k)
            gvdwpsb(k,j)=gvdwpsb(k,j)+ggg(k)
          enddo
        enddo

        enddo ! iint
      enddo ! i
      do i=1,nct
        do j=1,3
          gvdwpsb(j,i)=expon*gvdwpsb(j,i)
          gvdwpsb1(j,i)=expon*gvdwpsb1(j,i)
        enddo
      enddo
C******************************************************************************
C
C                              N O T E !!!
C
C To save time the factor EXPON has been extracted from ALL components
C of GVDWC and GRADX. Remember to multiply them by this factor before further 
C use!
C
C******************************************************************************
      return
      end
C--------------------------------------------------------------------------
      subroutine edis(ehpb)
C 
C Evaluate bridge-strain energy and its gradient in virtual-bond and SC vectors.
C
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.SBRIDGE'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.VAR'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      dimension ggg(3)
      ehpb=0.0D0
cd      write(iout,*)'edis: nhpb=',nhpb,' fbr=',fbr
cd      write(iout,*)'link_start=',link_start,' link_end=',link_end
      if (link_end.eq.0) return
      do i=link_start,link_end
C If ihpb(i) and jhpb(i) > NRES, this is a SC-SC distance, otherwise a
C CA-CA distance used in regularization of structure.
        ii=ihpb(i)
        jj=jhpb(i)
C iii and jjj point to the residues for which the distance is assigned.
        if (ii.gt.nres) then
          iii=ii-nres
          jjj=jj-nres 
        else
          iii=ii
          jjj=jj
        endif
C Calculate the distance between the two points and its difference from the
C target distance.
        dd=dist(ii,jj)
        rdis=dd-dhpb(i)
C Get the force constant corresponding to this distance.
        waga=forcon(i)
C Calculate the contribution to energy.
        ehpb=ehpb+waga*rdis*rdis
C
C Evaluate gradient.
C
        fac=waga*rdis/dd
cd      print *,'i=',i,' ii=',ii,' jj=',jj,' dhpb=',dhpb(i),' dd=',dd,
cd   &   ' waga=',waga,' fac=',fac
        do j=1,3
          ggg(j)=fac*(c(j,jj)-c(j,ii))
        enddo
cd      print '(i3,3(1pe14.5))',i,(ggg(j),j=1,3)
C If this is a SC-SC distance, we need to calculate the contributions to the
C Cartesian gradient in the SC vectors (ghpbx).
        if (iii.lt.ii) then
          do j=1,3
            ghpbx(j,iii)=ghpbx(j,iii)-ggg(j)
            ghpbx(j,jjj)=ghpbx(j,jjj)+ggg(j)
          enddo
        endif
cgrad        do j=iii,jjj-1
cgrad          do k=1,3
cgrad            ghpbc(k,j)=ghpbc(k,j)+ggg(k)
cgrad          enddo
cgrad        enddo
        do k=1,3
          ghpbc(k,jjj)=ghpbc(k,jjj)+ggg(k)
          ghpbc(k,iii)=ghpbc(k,iii)-ggg(k)
        enddo
      enddo
      ehpb=0.5D0*ehpb
      return
      end
C--------------------------------------------------------------------------
      subroutine ebond(estr)
c
c Evaluate the energy of stretching of the CA-CA and CA-SC virtual bonds
c
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.LOCAL'
      include 'COMMON.GEO'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.IOUNITS'
      include 'COMMON.NAMES'
      include 'COMMON.FFIELD'
      include 'COMMON.CONTROL'
      include 'COMMON.SETUP'
      double precision u(3),ud(3)
      estr=0.0d0
      if (energy_dec)
     &write (iout,*) "ibondp_start,ibondp_end",ibondp_start,ibondp_end,
     & " ibond_start,ibond_end",ibond_start,ibond_end
      if (energy_dec)
     & write (2,*) "nbondterm",(nbondterm(i),i=1,ntyp)
      do i=ibondp_start,ibondp_end
        if (itype(i-1).eq.ntyp1 .or. itype(i).eq.ntyp1) then
          estr1=estr1+gnmr1(vbld(i),-1.0d0,distchainmax)
          do j=1,3
          gradb(j,i-1)=gnmr1prim(vbld(i),-1.0d0,distchainmax)
     &      *dc(j,i-1)/vbld(i)
          enddo
          if (energy_dec) write(iout,*)
     &       "estr1",i,gnmr1(vbld(i),-1.0d0,distchainmax)
        else
          diff = vbld(i)-vbldp0
          if(energy_dec)write(iout,*)
     &      i,vbld(i),vbldp0,diff,AKP*diff*diff,estr
          estr=estr+diff*diff
          do j=1,3
            gradb(j,i-1)=AKP*diff*dc(j,i-1)/vbld(i)
          enddo
c          write (iout,'(i5,3f10.5)') i,(gradb(j,i-1),j=1,3)
        endif
      enddo
c      write (2,*) "After backbone estr",estr," estr1",estr1
      estr=0.5d0*AKP*estr+estr1
c
c 09/18/07 AL: multimodal bond potential based on AM1 CA-SC PMF's included
c
      do i=ibond_start,ibond_end
        iti=itype(i)
        if (iti.eq.ntyp1) cycle
          nbi=nbondterm(iti)
c          write (2,*) "i",i," iti",iti," nbi",nbi
          if (nbi.eq.1) then
            diff=vbld(i+nres)-vbldsc0(1,iti)
            estr=estr+0.5d0*AKSC(1,iti)*diff*diff
            if (energy_dec)
     &      write (iout,*) i,iti,vbld(i+nres),vbldsc0(1,iti),diff,
     &      AKSC(1,iti),AKSC(1,iti)*diff*diff,estr
            do j=1,3
              gradbx(j,i)=AKSC(1,iti)*diff*dc(j,i+nres)/vbld(i+nres)
            enddo
          else
            do j=1,nbi
              diff=vbld(i+nres)-vbldsc0(j,iti) 
              ud(j)=aksc(j,iti)*diff
              u(j)=abond0(j,iti)+0.5d0*ud(j)*diff
            enddo
            uprod=u(1)
            do j=2,nbi
              uprod=uprod*u(j)
            enddo
            usum=0.0d0
            usumsqder=0.0d0
            do j=1,nbi
              uprod1=1.0d0
              uprod2=1.0d0
              do k=1,nbi
                if (k.ne.j) then
                  uprod1=uprod1*u(k)
                  uprod2=uprod2*u(k)*u(k)
                endif
              enddo
              usum=usum+uprod1
              usumsqder=usumsqder+ud(j)*uprod2   
            enddo
            estr=estr+uprod/usum
            do j=1,3
             gradbx(j,i)=usumsqder/(usum*usum)*dc(j,i+nres)/vbld(i+nres)
            enddo
          endif
      enddo
c      write (2,*) "After sidechain estr",estr," estr1",estr1
      return
      end 
C--------------------------------------------------------------------------
      subroutine ebend(etheta)
C
C Evaluate the virtual-bond-angle energy given the virtual-bond dihedral
C angles gamma and its derivatives in consecutive thetas and gammas.
C ab initio-derived potentials from 
c Kozlowska et al., J. Phys.: Condens. Matter 19 (2007) 285203
C
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.LOCAL'
      include 'COMMON.GEO'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.IOUNITS'
      include 'COMMON.NAMES'
      include 'COMMON.FFIELD'
      include 'COMMON.CONTROL'
      double precision coskt(mmaxtheterm),sinkt(mmaxtheterm),
     & cosph1(maxsingle),sinph1(maxsingle),cosph2(maxsingle),
     & sinph2(maxsingle),cosph1ph2(maxdouble,maxdouble),
     & sinph1ph2(maxdouble,maxdouble)
      logical lprn /.false./, lprn1 /.false./
      etheta=0.0D0
c      print *,"ithet_start",ithet_start," ithet_end",ithet_end
      do i=ithet_start,ithet_end
        if (itype(i-1).eq.ntyp1) cycle
        dethetai=0.0d0
        dephii=0.0d0
        dephii1=0.0d0
        theti2=0.5d0*theta(i)
        ityp2=ithetyp(itype(i-1))
        do k=1,nntheterm
          coskt(k)=dcos(k*theti2)
          sinkt(k)=dsin(k*theti2)
        enddo
        if (i.gt.3 .and. itype(i-2).ne.ntyp1) then
#ifdef OSF
          phii=phi(i)
          if (phii.ne.phii) phii=150.0
#else
          phii=phi(i)
#endif
          ityp1=ithetyp(itype(i-2))
          do k=1,nsingle
            cosph1(k)=dcos(k*phii)
            sinph1(k)=dsin(k*phii)
          enddo
        else
          phii=0.0d0
          ityp1=nthetyp+1
          do k=1,nsingle
            cosph1(k)=0.0d0
            sinph1(k)=0.0d0
          enddo 
        endif
        if (i.lt.nres .and. itype(i).ne.ntyp1) then
#ifdef OSF
          phii1=phi(i+1)
          if (phii1.ne.phii1) phii1=150.0
          phii1=pinorm(phii1)
#else
          phii1=phi(i+1)
#endif
          ityp3=ithetyp(itype(i))
          do k=1,nsingle
            cosph2(k)=dcos(k*phii1)
            sinph2(k)=dsin(k*phii1)
          enddo
        else
          phii1=0.0d0
          ityp3=nthetyp+1
          do k=1,nsingle
            cosph2(k)=0.0d0
            sinph2(k)=0.0d0
          enddo
        endif  
        ethetai=aa0thet(ityp1,ityp2,ityp3)
        do k=1,ndouble
          do l=1,k-1
            ccl=cosph1(l)*cosph2(k-l)
            ssl=sinph1(l)*sinph2(k-l)
            scl=sinph1(l)*cosph2(k-l)
            csl=cosph1(l)*sinph2(k-l)
            cosph1ph2(l,k)=ccl-ssl
            cosph1ph2(k,l)=ccl+ssl
            sinph1ph2(l,k)=scl+csl
            sinph1ph2(k,l)=scl-csl
          enddo
        enddo
        if (lprn) then
        write (iout,*) "i",i," ityp1",ityp1," ityp2",ityp2,
     &    " ityp3",ityp3," theti2",theti2," phii",phii," phii1",phii1
        write (iout,*) "coskt and sinkt"
        do k=1,nntheterm
          write (iout,*) k,coskt(k),sinkt(k)
        enddo
        endif
        do k=1,ntheterm
          ethetai=ethetai+aathet(k,ityp1,ityp2,ityp3)*sinkt(k)
          dethetai=dethetai+0.5d0*k*aathet(k,ityp1,ityp2,ityp3)
     &      *coskt(k)
          if (lprn)
     &    write (iout,*) "k",k," aathet",aathet(k,ityp1,ityp2,ityp3),
     &     " ethetai",ethetai
        enddo
        if (lprn) then
        write (iout,*) "cosph and sinph"
        do k=1,nsingle
          write (iout,*) k,cosph1(k),sinph1(k),cosph2(k),sinph2(k)
        enddo
        write (iout,*) "cosph1ph2 and sinph2ph2"
        do k=2,ndouble
          do l=1,k-1
            write (iout,*) l,k,cosph1ph2(l,k),cosph1ph2(k,l),
     &         sinph1ph2(l,k),sinph1ph2(k,l) 
          enddo
        enddo
        write(iout,*) "ethetai",ethetai
        endif
        do m=1,ntheterm2
          do k=1,nsingle
            aux=bbthet(k,m,ityp1,ityp2,ityp3)*cosph1(k)
     &         +ccthet(k,m,ityp1,ityp2,ityp3)*sinph1(k)
     &         +ddthet(k,m,ityp1,ityp2,ityp3)*cosph2(k)
     &         +eethet(k,m,ityp1,ityp2,ityp3)*sinph2(k)
            ethetai=ethetai+sinkt(m)*aux
            dethetai=dethetai+0.5d0*m*aux*coskt(m)
            dephii=dephii+k*sinkt(m)*(
     &          ccthet(k,m,ityp1,ityp2,ityp3)*cosph1(k)-
     &          bbthet(k,m,ityp1,ityp2,ityp3)*sinph1(k))
            dephii1=dephii1+k*sinkt(m)*(
     &          eethet(k,m,ityp1,ityp2,ityp3)*cosph2(k)-
     &          ddthet(k,m,ityp1,ityp2,ityp3)*sinph2(k))
            if (lprn)
     &      write (iout,*) "m",m," k",k," bbthet",
     &         bbthet(k,m,ityp1,ityp2,ityp3)," ccthet",
     &         ccthet(k,m,ityp1,ityp2,ityp3)," ddthet",
     &         ddthet(k,m,ityp1,ityp2,ityp3)," eethet",
     &         eethet(k,m,ityp1,ityp2,ityp3)," ethetai",ethetai
          enddo
        enddo
        if (lprn)
     &  write(iout,*) "ethetai",ethetai
        do m=1,ntheterm3
          do k=2,ndouble
            do l=1,k-1
              aux=ffthet(l,k,m,ityp1,ityp2,ityp3)*cosph1ph2(l,k)+
     &            ffthet(k,l,m,ityp1,ityp2,ityp3)*cosph1ph2(k,l)+
     &            ggthet(l,k,m,ityp1,ityp2,ityp3)*sinph1ph2(l,k)+
     &            ggthet(k,l,m,ityp1,ityp2,ityp3)*sinph1ph2(k,l)
              ethetai=ethetai+sinkt(m)*aux
              dethetai=dethetai+0.5d0*m*coskt(m)*aux
              dephii=dephii+l*sinkt(m)*(
     &           -ffthet(l,k,m,ityp1,ityp2,ityp3)*sinph1ph2(l,k)-
     &            ffthet(k,l,m,ityp1,ityp2,ityp3)*sinph1ph2(k,l)+
     &            ggthet(l,k,m,ityp1,ityp2,ityp3)*cosph1ph2(l,k)+
     &            ggthet(k,l,m,ityp1,ityp2,ityp3)*cosph1ph2(k,l))
              dephii1=dephii1+(k-l)*sinkt(m)*(
     &           -ffthet(l,k,m,ityp1,ityp2,ityp3)*sinph1ph2(l,k)+
     &            ffthet(k,l,m,ityp1,ityp2,ityp3)*sinph1ph2(k,l)+
     &            ggthet(l,k,m,ityp1,ityp2,ityp3)*cosph1ph2(l,k)-
     &            ggthet(k,l,m,ityp1,ityp2,ityp3)*cosph1ph2(k,l))
              if (lprn) then
              write (iout,*) "m",m," k",k," l",l," ffthet",
     &            ffthet(l,k,m,ityp1,ityp2,ityp3),
     &            ffthet(k,l,m,ityp1,ityp2,ityp3)," ggthet",
     &            ggthet(l,k,m,ityp1,ityp2,ityp3),
     &            ggthet(k,l,m,ityp1,ityp2,ityp3)," ethetai",ethetai
              write (iout,*) cosph1ph2(l,k)*sinkt(m),
     &            cosph1ph2(k,l)*sinkt(m),
     &            sinph1ph2(l,k)*sinkt(m),sinph1ph2(k,l)*sinkt(m)
              endif
            enddo
          enddo
        enddo
10      continue
        if (lprn1) write (iout,'(i2,3f8.1,9h ethetai ,f10.5)') 
     &   i,theta(i)*rad2deg,phii*rad2deg,
     &   phii1*rad2deg,ethetai
        etheta=etheta+ethetai
        if (i.gt.3) gloc(i-3,icg)=gloc(i-3,icg)+wang*dephii
        if (i.lt.nres) gloc(i-2,icg)=gloc(i-2,icg)+wang*dephii1
        gloc(nphi+i-2,icg)=wang*dethetai
      enddo
      return
      end
c-------------------------------------------------------------------------------
      subroutine esb(esbloc)
C Calculate the local energy of a side chain and its derivatives in the
C corresponding virtual-bond valence angles THETA and the spherical angles 
C ALPHA and OMEGA derived from AM1 all-atom calculations.
C added by Urszula Kozlowska. 07/11/2007
C
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.SCROT'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.CHAIN'
      include 'COMMON.IOUNITS'
      include 'COMMON.NAMES'
      include 'COMMON.FFIELD'
      include 'COMMON.CONTROL'
      include 'COMMON.VECTORS'
      double precision x_prime(3),y_prime(3),z_prime(3)
     &    , sumene,dsc_i,dp2_i,x(9),
     &     xx,yy,zz,sumene1,sumene2,sumene3,sumene4,s1,s1_6,s2,s2_6,
     &    de_dxx,de_dyy,de_dzz,de_dt
      double precision s1_t,s1_6_t,s2_t,s2_6_t
      double precision 
     & dXX_Ci1(3),dYY_Ci1(3),dZZ_Ci1(3),dXX_Ci(3),
     & dYY_Ci(3),dZZ_Ci(3),dXX_XYZ(3),dYY_XYZ(3),dZZ_XYZ(3),
     & dt_dCi(3),dt_dCi1(3)
      common /sccalc/ time11,time12,time112,theti,it,nlobit
      delta=0.02d0*pi
      esbloc=0.0D0
      do i=loc_start,loc_end
        if (itype(i).eq.ntyp1) cycle
        costtab(i+1) =dcos(theta(i+1))
        sinttab(i+1) =dsqrt(1-costtab(i+1)*costtab(i+1))
        cost2tab(i+1)=dsqrt(0.5d0*(1.0d0+costtab(i+1)))
        sint2tab(i+1)=dsqrt(0.5d0*(1.0d0-costtab(i+1)))
        cosfac2=0.5d0/(1.0d0+costtab(i+1))
        cosfac=dsqrt(cosfac2)
        sinfac2=0.5d0/(1.0d0-costtab(i+1))
        sinfac=dsqrt(sinfac2)
        it=itype(i)
        if (it.eq.10) goto 1
c
C  Compute the axes of tghe local cartesian coordinates system; store in
c   x_prime, y_prime and z_prime 
c
        do j=1,3
          x_prime(j) = 0.00
          y_prime(j) = 0.00
          z_prime(j) = 0.00
        enddo
C        write(2,*) "dc_norm", dc_norm(1,i+nres),dc_norm(2,i+nres),
C     &   dc_norm(3,i+nres)
        do j = 1,3
          x_prime(j) = (dc_norm(j,i) - dc_norm(j,i-1))*cosfac
          y_prime(j) = (dc_norm(j,i) + dc_norm(j,i-1))*sinfac
        enddo
        do j = 1,3
          z_prime(j) = -uz(j,i-1)
        enddo     
c       write (2,*) "i",i
c       write (2,*) "x_prime",(x_prime(j),j=1,3)
c       write (2,*) "y_prime",(y_prime(j),j=1,3)
c       write (2,*) "z_prime",(z_prime(j),j=1,3)
c       write (2,*) "xx",scalar(x_prime(1),x_prime(1)),
c      & " xy",scalar(x_prime(1),y_prime(1)),
c      & " xz",scalar(x_prime(1),z_prime(1)),
c      & " yy",scalar(y_prime(1),y_prime(1)),
c      & " yz",scalar(y_prime(1),z_prime(1)),
c      & " zz",scalar(z_prime(1),z_prime(1))
c
C Transform the unit vector of the ith side-chain centroid, dC_norm(*,i),
C to local coordinate system. Store in xx, yy, zz.
c
        xx=0.0d0
        yy=0.0d0
        zz=0.0d0
        do j = 1,3
          xx = xx + x_prime(j)*dc_norm(j,i+nres)
          yy = yy + y_prime(j)*dc_norm(j,i+nres)
          zz = zz + z_prime(j)*dc_norm(j,i+nres)
        enddo

        xxtab(i)=xx
        yytab(i)=yy
        zztab(i)=zz
C
C Compute the energy of the ith side cbain
C
c        write (2,*) "xx",xx," yy",yy," zz",zz
        it=itype(i)
        do j = 1,9
          x(j) = sc_parmin(j,it) 
        enddo
#ifdef CHECK_COORD
Cc diagnostics - remove later
        xx1 = dcos(alph(2))
        yy1 = dsin(alph(2))*dcos(omeg(2))
        zz1 = -dsin(alph(2))*dsin(omeg(2))
        write(2,'(3f8.1,3f9.3,1x,3f9.3)') 
     &    alph(2)*rad2deg,omeg(2)*rad2deg,theta(3)*rad2deg,xx,yy,zz,
     &    xx1,yy1,zz1
C,"  --- ", xx_w,yy_w,zz_w
c end diagnostics
#endif
        sumene = enesc(x,xx,yy,zz,cost2tab(i+1),sint2tab(i+1))
        esbloc = esbloc + sumene
        if (energy_dec) write(iout,*) "i",i," esbloc",sumene,esbloc
#ifdef DEBUG
        write (2,*) "x",(x(k),k=1,9)
C
C This section to check the numerical derivatives of the energy of ith side
C chain in xx, yy, zz, and theta. Use the -DDEBUG compiler option or insert
C #define DEBUG in the code to turn it on.
C
        write (2,*) "sumene               =",sumene
        aincr=1.0d-7
        xxsave=xx
        xx=xx+aincr
        write (2,*) xx,yy,zz
        sumenep = enesc(x,xx,yy,zz,cost2tab(i+1),sint2tab(i+1))
        de_dxx_num=(sumenep-sumene)/aincr
        xx=xxsave
        write (2,*) "xx+ sumene from enesc=",sumenep,sumene
        yysave=yy
        yy=yy+aincr
        write (2,*) xx,yy,zz
        sumenep = enesc(x,xx,yy,zz,cost2tab(i+1),sint2tab(i+1))
        de_dyy_num=(sumenep-sumene)/aincr
        yy=yysave
        write (2,*) "yy+ sumene from enesc=",sumenep,sumene
        zzsave=zz
        zz=zz+aincr
        write (2,*) xx,yy,zz
        sumenep = enesc(x,xx,yy,zz,cost2tab(i+1),sint2tab(i+1))
        de_dzz_num=(sumenep-sumene)/aincr
        zz=zzsave
        write (2,*) "zz+ sumene from enesc=",sumenep,sumene
        costsave=cost2tab(i+1)
        sintsave=sint2tab(i+1)
        cost2tab(i+1)=dcos(0.5d0*(theta(i+1)+aincr))
        sint2tab(i+1)=dsin(0.5d0*(theta(i+1)+aincr))
        sumenep = enesc(x,xx,yy,zz,cost2tab(i+1),sint2tab(i+1))
        de_dt_num=(sumenep-sumene)/aincr
        write (2,*) " t+ sumene from enesc=",sumenep,sumene
        cost2tab(i+1)=costsave
        sint2tab(i+1)=sintsave
C End of diagnostics section.
#endif
C        
C Compute the gradient of esc
C
        de_dxx=x(1)+2*x(4)*xx+x(7)*zz+x(8)*yy
        de_dyy=x(2)+2*x(5)*yy+x(8)*xx+x(9)*zz
        de_dzz=x(3)+2*x(6)*zz+x(7)*xx+x(9)*yy
        de_dtt=0.0d0
#ifdef DEBUG
        write (2,*) "x",(x(k),k=1,9)
        write (2,*) "xx",xx," yy",yy," zz",zz
        write (2,*) "de_xx   ",de_xx," de_yy   ",de_yy,
     &     " de_zz   ",de_zz," de_tt   ",de_tt
        write (2,*) "de_xx_num",de_dxx_num," de_yy_num",de_dyy_num,
     &     " de_zz_num",de_dzz_num," de_dt_num",de_dt_num
#endif
C
       cossc=scalar(dc_norm(1,i),dc_norm(1,i+nres))
       cossc1=scalar(dc_norm(1,i-1),dc_norm(1,i+nres))
       cosfac2xx=cosfac2*xx
       sinfac2yy=sinfac2*yy
       do k = 1,3
         dt_dCi(k) = -(dc_norm(k,i-1)+costtab(i+1)*dc_norm(k,i))*
     &      vbld_inv(i+1)
         dt_dCi1(k)= -(dc_norm(k,i)+costtab(i+1)*dc_norm(k,i-1))*
     &      vbld_inv(i)
         pom=(dC_norm(k,i+nres)-cossc*dC_norm(k,i))*vbld_inv(i+1)
         pom1=(dC_norm(k,i+nres)-cossc1*dC_norm(k,i-1))*vbld_inv(i)
c         write (iout,*) "i",i," k",k," pom",pom," pom1",pom1,
c     &    " dt_dCi",dt_dCi(k)," dt_dCi1",dt_dCi1(k)
c         write (iout,*) "dC_norm",(dC_norm(j,i),j=1,3),
c     &   (dC_norm(j,i-1),j=1,3)," vbld_inv",vbld_inv(i+1),vbld_inv(i)
         dXX_Ci(k)=pom*cosfac-dt_dCi(k)*cosfac2xx
         dXX_Ci1(k)=-pom1*cosfac-dt_dCi1(k)*cosfac2xx
         dYY_Ci(k)=pom*sinfac+dt_dCi(k)*sinfac2yy
         dYY_Ci1(k)=pom1*sinfac+dt_dCi1(k)*sinfac2yy
         dZZ_Ci1(k)=0.0d0
         dZZ_Ci(k)=0.0d0
         do j=1,3
           dZZ_Ci(k)=dZZ_Ci(k)-uzgrad(j,k,2,i-1)*dC_norm(j,i+nres)
           dZZ_Ci1(k)=dZZ_Ci1(k)-uzgrad(j,k,1,i-1)*dC_norm(j,i+nres)
         enddo
          
         dXX_XYZ(k)=vbld_inv(i+nres)*(x_prime(k)-xx*dC_norm(k,i+nres))
         dYY_XYZ(k)=vbld_inv(i+nres)*(y_prime(k)-yy*dC_norm(k,i+nres))
         dZZ_XYZ(k)=vbld_inv(i+nres)*(z_prime(k)-zz*dC_norm(k,i+nres))
c
         dt_dCi(k) = -dt_dCi(k)/sinttab(i+1)
         dt_dCi1(k)= -dt_dCi1(k)/sinttab(i+1)
       enddo

       do k=1,3
         dXX_Ctab(k,i)=dXX_Ci(k)
         dXX_C1tab(k,i)=dXX_Ci1(k)
         dYY_Ctab(k,i)=dYY_Ci(k)
         dYY_C1tab(k,i)=dYY_Ci1(k)
         dZZ_Ctab(k,i)=dZZ_Ci(k)
         dZZ_C1tab(k,i)=dZZ_Ci1(k)
         dXX_XYZtab(k,i)=dXX_XYZ(k)
         dYY_XYZtab(k,i)=dYY_XYZ(k)
         dZZ_XYZtab(k,i)=dZZ_XYZ(k)
       enddo

       do k = 1,3
c         write (iout,*) "k",k," dxx_ci1",dxx_ci1(k)," dyy_ci1",
c     &    dyy_ci1(k)," dzz_ci1",dzz_ci1(k)
c         write (iout,*) "k",k," dxx_ci",dxx_ci(k)," dyy_ci",
c     &    dyy_ci(k)," dzz_ci",dzz_ci(k)
c         write (iout,*) "k",k," dt_dci",dt_dci(k)," dt_dci",
c     &    dt_dci(k)
c         write (iout,*) "k",k," dxx_XYZ",dxx_XYZ(k)," dyy_XYZ",
c     &    dyy_XYZ(k)," dzz_XYZ",dzz_XYZ(k) 
         gsbloc(k,i-1)=gsbloc(k,i-1)+de_dxx*dxx_ci1(k)
     &    +de_dyy*dyy_ci1(k)+de_dzz*dzz_ci1(k)+de_dt*dt_dCi1(k)
         gsbloc(k,i)=gsbloc(k,i)+de_dxx*dxx_Ci(k)
     &    +de_dyy*dyy_Ci(k)+de_dzz*dzz_Ci(k)+de_dt*dt_dCi(k)
         gsblocx(k,i)=                 de_dxx*dxx_XYZ(k)
     &    +de_dyy*dyy_XYZ(k)+de_dzz*dzz_XYZ(k)
       enddo
c       write(iout,*) "ENERGY GRAD = ", (gsbloc(k,i-1),k=1,3),
c     &  (gsbloc(k,i),k=1,3),(gsblocx(k,i),k=1,3)  

C to check gradient call subroutine check_grad

    1 continue
      enddo
      return
      end
c------------------------------------------------------------------------------
      double precision function enesc(x,xx,yy,zz,cost2,sint2)
      implicit none
      double precision x(9),xx,yy,zz,cost2,sint2,sumene1,sumene2,
     & sumene3,sumene4,sumene,dsc_i,dp2_i,dscp1,dscp2,s1,s1_6,s2,s2_6
      integer i
c      write (2,*) "enesc"
c      write (2,*) "x",(x(i),i=1,9)
c      write(2,*)"xx",xx," yy",yy," zz",zz," cost2",cost2," sint2",sint2
      sumene=x(1)*xx+x(2)*yy+x(3)*zz+x(4)*xx**2
     &   + x(5)*yy**2+x(6)*zz**2+x(7)*xx*zz+x(8)*xx*yy
     &   + x(9)*yy*zz
      enesc=sumene
      return
      end
c------------------------------------------------------------------------------
      subroutine gcont(rij,r0ij,eps0ij,delta,fcont,fprimcont)
C
C This procedure calculates two-body contact function g(rij) and its derivative:
C
C           eps0ij                                     !       x < -1
C g(rij) =  esp0ij*(-0.9375*x+0.625*x**3-0.1875*x**5)  ! -1 =< x =< 1
C            0                                         !       x > 1
C
C where x=(rij-r0ij)/delta
C
C rij - interbody distance, r0ij - contact distance, eps0ij - contact energy
C
      implicit none
      double precision rij,r0ij,eps0ij,fcont,fprimcont
      double precision x,x2,x4,delta
c     delta=0.02D0*r0ij
c      delta=0.2D0*r0ij
      x=(rij-r0ij)/delta
      if (x.lt.-1.0D0) then
        fcont=eps0ij
        fprimcont=0.0D0
      else if (x.le.1.0D0) then  
        x2=x*x
        x4=x2*x2
        fcont=eps0ij*(x*(-0.9375D0+0.6250D0*x2-0.1875D0*x4)+0.5D0)
        fprimcont=eps0ij * (-0.9375D0+1.8750D0*x2-0.9375D0*x4)/delta
      else
        fcont=0.0D0
        fprimcont=0.0D0
      endif
      return
      end
c------------------------------------------------------------------------------
      subroutine splinthet(theti,delta,ss,ssder)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.GEO'
      thetup=pi-delta
      thetlow=delta
      if (theti.gt.pipol) then
        call gcont(theti,thetup,1.0d0,delta,ss,ssder)
      else
        call gcont(-theti,-thetlow,1.0d0,delta,ss,ssder)
        ssder=-ssder
      endif
      return
      end
c------------------------------------------------------------------------------
      subroutine spline1(x,x0,delta,f0,f1,fprim0,f,fprim)
      implicit none
      double precision x,x0,delta,f0,f1,fprim0,f,fprim
      double precision ksi,ksi2,ksi3,a1,a2,a3
      a1=fprim0*delta/(f1-f0)
      a2=3.0d0-2.0d0*a1
      a3=a1-2.0d0
      ksi=(x-x0)/delta
      ksi2=ksi*ksi
      ksi3=ksi2*ksi  
      f=f0+(f1-f0)*ksi*(a1+ksi*(a2+a3*ksi))
      fprim=(f1-f0)/delta*(a1+ksi*(2*a2+3*ksi*a3))
      return
      end
c------------------------------------------------------------------------------
      subroutine spline2(x,x0,delta,f0x,f1x,fprim0x,fx)
      implicit none
      double precision x,x0,delta,f0x,f1x,fprim0x,fx
      double precision ksi,ksi2,ksi3,a1,a2,a3
      ksi=(x-x0)/delta  
      ksi2=ksi*ksi
      ksi3=ksi2*ksi
      a1=fprim0x*delta
      a2=3*(f1x-f0x)-2*fprim0x*delta
      a3=fprim0x*delta-2*(f1x-f0x)
      fx=f0x+a1*ksi+a2*ksi2+a3*ksi3
      return
      end
C-----------------------------------------------------------------------------
      subroutine etor(etors,edihcnstr)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.VAR'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.TORSION'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.CHAIN'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.TORCNSTR'
      include 'COMMON.CONTROL'
      logical lprn
C Set lprn=.true. for debugging
      lprn=.false.
c     lprn=.true.
      etors=0.0D0
      do i=iphi_start,iphi_end
      etors_ii=0.0D0
        if (itype(i-2).eq.ntyp1 .or. itype(i-1).eq.ntyp1
     &      .or. itype(i).eq.ntyp1) cycle
        itori=itortyp(itype(i-2))
        itori1=itortyp(itype(i-1))
        phii=phi(i)
        gloci=0.0D0
C Regular cosine and sine terms
        do j=1,nterm(itori,itori1)
          v1ij=v1(j,itori,itori1)
          v2ij=v2(j,itori,itori1)
          cosphi=dcos(j*phii)
          sinphi=dsin(j*phii)
          etors=etors+v1ij*cosphi+v2ij*sinphi
          if (energy_dec) etors_ii=etors_ii+
     &                v1ij*cosphi+v2ij*sinphi
          gloci=gloci+j*(v2ij*cosphi-v1ij*sinphi)
        enddo
C Lorentz terms
C                         v1
C  E = SUM ----------------------------------- - v1
C          [v2 cos(phi/2)+v3 sin(phi/2)]^2 + 1
C
        cosphi=dcos(0.5d0*phii)
        sinphi=dsin(0.5d0*phii)
        do j=1,nlor(itori,itori1)
          vl1ij=vlor1(j,itori,itori1)
          vl2ij=vlor2(j,itori,itori1)
          vl3ij=vlor3(j,itori,itori1)
          pom=vl2ij*cosphi+vl3ij*sinphi
          pom1=1.0d0/(pom*pom+1.0d0)
          etors=etors+vl1ij*pom1
          if (energy_dec) etors_ii=etors_ii+
     &                vl1ij*pom1
          pom=-pom*pom1*pom1
          gloci=gloci+vl1ij*(vl3ij*cosphi-vl2ij*sinphi)*pom
        enddo
C Subtract the constant term
        etors=etors-v0(itori,itori1)
          if (energy_dec) write (iout,'(a6,i5,0pf7.3)')
     &         'etor',i,etors_ii-v0(itori,itori1)
        if (lprn)
     &  write (iout,'(2(a3,2x,i3,2x),2i3,6f8.3/26x,6f8.3/)')
     &  restyp(itype(i-2)),i-2,restyp(itype(i-1)),i-1,itori,itori1,
     &  (v1(j,itori,itori1),j=1,6),(v2(j,itori,itori1),j=1,6)
        gloc(i-3,icg)=gloc(i-3,icg)+wtor*gloci
c       write (iout,*) 'i=',i,' gloc=',gloc(i-3,icg)
      enddo
! 6/20/98 - dihedral angle constraints
      edihcnstr=0.0d0
c      do i=1,ndih_constr
      do i=idihconstr_start,idihconstr_end
        itori=idih_constr(i)
        phii=phi(itori)
        difi=pinorm(phii-phi0(i))
        if (difi.gt.drange(i)) then
          difi=difi-drange(i)
          edihcnstr=edihcnstr+0.25d0*ftors*difi**4
          gloc(itori-3,icg)=gloc(itori-3,icg)+ftors*difi**3
        else if (difi.lt.-drange(i)) then
          difi=difi+drange(i)
          edihcnstr=edihcnstr+0.25d0*ftors*difi**4
          gloc(itori-3,icg)=gloc(itori-3,icg)+ftors*difi**3
        else
          difi=0.0
        endif
cd        write (iout,'(2i5,4f8.3,2e14.5)') i,itori,rad2deg*phii,
cd     &    rad2deg*phi0(i),  rad2deg*drange(i),
cd     &    rad2deg*difi,0.25d0*ftors*difi**4,gloc(itori-3,icg)
      enddo
cd       write (iout,*) 'edihcnstr',edihcnstr
      return
      end
c----------------------------------------------------------------------------
      subroutine etor_d(etors_d)
C 6/23/01 Compute double torsional energy
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.VAR'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.TORSION'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.CHAIN'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.TORCNSTR'
      logical lprn
C Set lprn=.true. for debugging
      lprn=.false.
c     lprn=.true.
      etors_d=0.0D0
      do i=iphid_start,iphid_end
        if (itype(i-2).eq.ntyp1 .or. itype(i-1).eq.ntyp1
     &      .or. itype(i).eq.ntyp1 .or. itype(i+1).eq.ntyp1) cycle
        itori=itortyp(itype(i-2))
        itori1=itortyp(itype(i-1))
        itori2=itortyp(itype(i))
        phii=phi(i)
        phii1=phi(i+1)
        gloci1=0.0D0
        gloci2=0.0D0
C Regular cosine and sine terms
        do j=1,ntermd_1(itori,itori1,itori2)
          v1cij=v1c(1,j,itori,itori1,itori2)
          v1sij=v1s(1,j,itori,itori1,itori2)
          v2cij=v1c(2,j,itori,itori1,itori2)
          v2sij=v1s(2,j,itori,itori1,itori2)
          cosphi1=dcos(j*phii)
          sinphi1=dsin(j*phii)
          cosphi2=dcos(j*phii1)
          sinphi2=dsin(j*phii1)
          etors_d=etors_d+v1cij*cosphi1+v1sij*sinphi1+
     &     v2cij*cosphi2+v2sij*sinphi2
          gloci1=gloci1+j*(v1sij*cosphi1-v1cij*sinphi1)
          gloci2=gloci2+j*(v2sij*cosphi2-v2cij*sinphi2)
        enddo
        do k=2,ntermd_2(itori,itori1,itori2)
          do l=1,k-1
            v1cdij = v2c(k,l,itori,itori1,itori2)
            v2cdij = v2c(l,k,itori,itori1,itori2)
            v1sdij = v2s(k,l,itori,itori1,itori2)
            v2sdij = v2s(l,k,itori,itori1,itori2)
            cosphi1p2=dcos(l*phii+(k-l)*phii1)
            cosphi1m2=dcos(l*phii-(k-l)*phii1)
            sinphi1p2=dsin(l*phii+(k-l)*phii1)
            sinphi1m2=dsin(l*phii-(k-l)*phii1)
            etors_d=etors_d+v1cdij*cosphi1p2+v2cdij*cosphi1m2+
     &        v1sdij*sinphi1p2+v2sdij*sinphi1m2
            gloci1=gloci1+l*(v1sdij*cosphi1p2+v2sdij*cosphi1m2
     &        -v1cdij*sinphi1p2-v2cdij*sinphi1m2)
            gloci2=gloci2+(k-l)*(v1sdij*cosphi1p2-v2sdij*cosphi1m2
     &        -v1cdij*sinphi1p2+v2cdij*sinphi1m2) 
          enddo
        enddo
        gloc(i-3,icg)=gloc(i-3,icg)+wtor_d*gloci1
        gloc(i-2,icg)=gloc(i-2,icg)+wtor_d*gloci2
      enddo
      return
      end
c------------------------------------------------------------------------------
#if defined(MPI) && defined(FINEGRAIN)
      subroutine pack_buffer(dimen1,dimen2,atom,indx,buffer)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS' 
      integer dimen1,dimen2,atom,indx
      double precision buffer(dimen1,dimen2)
      double precision zapas 
      common /contacts_hb/ zapas(3,maxconts,maxres,8),
     &   facont_hb(maxconts,maxres),ees0p(maxconts,maxres),
     &         ees0m(maxconts,maxres),d_cont(maxconts,maxres),
     &         num_cont_hb(maxres),jcont_hb(maxconts,maxres)
      num_kont=num_cont_hb(atom)
      do i=1,num_kont
        do k=1,8
          do j=1,3
            buffer(i,indx+(k-1)*3+j)=zapas(j,i,atom,k)
          enddo ! j
        enddo ! k
        buffer(i,indx+25)=facont_hb(i,atom)
        buffer(i,indx+26)=ees0p(i,atom)
        buffer(i,indx+27)=ees0m(i,atom)
        buffer(i,indx+28)=d_cont(i,atom)
        buffer(i,indx+29)=dfloat(jcont_hb(i,atom))
      enddo ! i
      buffer(1,indx+30)=dfloat(num_kont)
      return
      end
c------------------------------------------------------------------------------
      subroutine unpack_buffer(dimen1,dimen2,atom,indx,buffer)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS' 
      integer dimen1,dimen2,atom,indx
      double precision buffer(dimen1,dimen2)
      double precision zapas 
      common /contacts_hb/ zapas(3,maxconts,maxres,8),
     &   facont_hb(maxconts,maxres),ees0p(maxconts,maxres),
     &         ees0m(maxconts,maxres),d_cont(maxconts,maxres),
     &         num_cont_hb(maxres),jcont_hb(maxconts,maxres)
      num_kont=buffer(1,indx+30)
      num_kont_old=num_cont_hb(atom)
      num_cont_hb(atom)=num_kont+num_kont_old
      do i=1,num_kont
        ii=i+num_kont_old
        do k=1,8    
          do j=1,3
            zapas(j,ii,atom,k)=buffer(i,indx+(k-1)*3+j)
          enddo ! j 
        enddo ! k 
        facont_hb(ii,atom)=buffer(i,indx+25)
        ees0p(ii,atom)=buffer(i,indx+26)
        ees0m(ii,atom)=buffer(i,indx+27)
        d_cont(i,atom)=buffer(i,indx+28)
        jcont_hb(ii,atom)=buffer(i,indx+29)
      enddo ! i
      return
      end
c------------------------------------------------------------------------------
#endif
      subroutine multibody_hb(ecorr,ecorr3,n_corr,n_corr1)
C This subroutine calculates multi-body contributions to hydrogen-bonding 
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.IOUNITS'
#if defined(MPI) && defined(FINEGRAIN)
      include "mpif.h"
      parameter (max_cont=maxconts)
      parameter (max_dim=2*(8*3+6))
      parameter (msglen1=max_cont*max_dim)
      parameter (msglen2=2*msglen1)
      integer source,CorrelType,CorrelID,Error
      double precision buffer(max_cont,max_dim)
      integer status(MPI_STATUS_SIZE)
#endif
      include 'COMMON.SETUP'
      include 'COMMON.FFIELD'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      include 'COMMON.CONTROL'
      double precision gx(3),gx1(3),time00
      logical lprn,ldone
C Set lprn=.true. for debugging
      lprn=.false.
      n_corr=0
      n_corr1=0
#if defined(MPI) && defined(FINEGRAIN)
      if (nfgtasks.le.1) goto 30
      if (lprn) then
        write (iout,'(a)') 'Contact function values:'
        do i=nnt,nct-1
          write (iout,'(2i3,50(1x,i2,f5.2))') 
     &    i,num_cont_hb(i),(jcont_hb(j,i),facont_hb(j,i),
     &    j=1,num_cont_hb(i))
        enddo
      endif
C Caution! Following code assumes that electrostatic interactions concerning
C a given atom are split among at most two processors!
      CorrelType=477
      CorrelID=fg_rank+1
      ldone=.false.
      do i=1,max_cont
        do j=1,max_dim
          buffer(i,j)=0.0D0
        enddo
      enddo
      mm=mod(fg_rank,2)
c      write (*,*) 'MyRank',MyRank,' mm',mm
      if (mm) 20,20,10 
   10 continue
c      write (*,*) 'Sending: MyRank',MyRank,' mm',mm,' ldone',ldone
      if (fg_rank.gt.0) then
C Send correlation contributions to the preceding processor
        msglen=msglen1
        nn=num_cont_hb(iatel_s)
        call pack_buffer(max_cont,max_dim,iatel_s,0,buffer)
c        write (*,*) 'The BUFFER array:'
c        do i=1,nn
c          write (*,'(i2,9(3f8.3,2x))') i,(buffer(i,j),j=1,30)
c        enddo
        if (ielstart(iatel_s).gt.iatel_s+ispp) then
          msglen=msglen2
          call pack_buffer(max_cont,max_dim,iatel_s+1,30,buffer)
C Clear the contacts of the atom passed to the neighboring processor
        nn=num_cont_hb(iatel_s+1)
c        do i=1,nn
c          write (*,'(i2,9(3f8.3,2x))') i,(buffer(i,j+30),j=1,30)
c        enddo
            num_cont_hb(iatel_s)=0
        endif 
cd      write (iout,*) 'Processor ',fg_rank,MyRank,
cd   & ' is sending correlation contribution to processor',fg_rank-1,
cd   & ' msglen=',msglen
c        write (*,*) 'Processor ',fg_rank,MyRank,
c     & ' is sending correlation contribution to processor',fg_rank-1,
c     & ' msglen=',msglen,' CorrelType=',CorrelType
        time00=MPI_Wtime()
        call MPI_Send(buffer,msglen,MPI_DOUBLE_PRECISION,fg_rank-1,
     &    CorrelType,FG_COMM,IERROR)
        time_sendrecv=time_sendrecv+MPI_Wtime()-time00
cd      write (iout,*) 'Processor ',fg_rank,
cd   & ' has sent correlation contribution to processor',fg_rank-1,
cd   & ' msglen=',msglen,' CorrelID=',CorrelID
c        write (*,*) 'Processor ',fg_rank,
c     & ' has sent correlation contribution to processor',fg_rank-1,
c     & ' msglen=',msglen,' CorrelID=',CorrelID
c        msglen=msglen1
      endif ! (fg_rank.gt.0)
      if (ldone) goto 30
      ldone=.true.
   20 continue
c      write (*,*) 'Receiving: MyRank',MyRank,' mm',mm,' ldone',ldone
      if (fg_rank.lt.nfgtasks-1) then
C Receive correlation contributions from the next processor
        msglen=msglen1
        if (ielend(iatel_e).lt.nct-1) msglen=msglen2
cd      write (iout,*) 'Processor',fg_rank,
cd   & ' is receiving correlation contribution from processor',fg_rank+1,
cd   & ' msglen=',msglen,' CorrelType=',CorrelType
c        write (*,*) 'Processor',fg_rank,
c     &' is receiving correlation contribution from processor',fg_rank+1,
c     & ' msglen=',msglen,' CorrelType=',CorrelType
        time00=MPI_Wtime()
        nbytes=-1
        do while (nbytes.le.0)
          call MPI_Probe(fg_rank+1,CorrelType,FG_COMM,status,IERROR)
          call MPI_Get_count(status,MPI_DOUBLE_PRECISION,nbytes,IERROR)
        enddo
c        print *,'Processor',myrank,' msglen',msglen,' nbytes',nbytes
        call MPI_Recv(buffer,nbytes,MPI_DOUBLE_PRECISION,
     &    fg_rank+1,CorrelType,FG_COMM,status,IERROR)
        time_sendrecv=time_sendrecv+MPI_Wtime()-time00
c        write (*,*) 'Processor',fg_rank,
c     &' has received correlation contribution from processor',fg_rank+1,
c     & ' msglen=',msglen,' nbytes=',nbytes
c        write (*,*) 'The received BUFFER array:'
c        do i=1,max_cont
c          write (*,'(i2,9(3f8.3,2x))') i,(buffer(i,j),j=1,60)
c        enddo
        if (msglen.eq.msglen1) then
          call unpack_buffer(max_cont,max_dim,iatel_e+1,0,buffer)
        else if (msglen.eq.msglen2)  then
          call unpack_buffer(max_cont,max_dim,iatel_e,0,buffer) 
          call unpack_buffer(max_cont,max_dim,iatel_e+1,30,buffer) 
        else
          write (iout,*) 
     & 'ERROR!!!! message length changed while processing correlations.'
          write (*,*) 
     & 'ERROR!!!! message length changed while processing correlations.'
          call MPI_Abort(MPI_COMM_WORLD,Error,IERROR)
        endif ! msglen.eq.msglen1
      endif ! fg_rank.lt.nfgtasks-1
      if (ldone) goto 30
      ldone=.true.
      goto 10
   30 continue
#endif
      if (lprn) then
        write (iout,'(a)') 'Contact function values:'
        do i=nnt,nct-1
          write (iout,'(2i3,50(1x,i2,f5.2))') 
     &    i,num_cont_hb(i),(jcont_hb(j,i),facont_hb(j,i),
     &    j=1,num_cont_hb(i))
        enddo
      endif
      ecorr=0.0D0
      ecorr3=0.0d0
C Remove the loop below after debugging !!!
      do i=nnt,nct
        do j=1,3
          gradcorr(j,i)=0.0D0
          gradxorr(j,i)=0.0D0
          gradcorr3(j,i)=0.0D0
          gradxorr3(j,i)=0.0D0
        enddo
      enddo
C Calculate the local-electrostatic correlation terms
      do i=iatsc_s,iatsc_e
        i1=i+1
        num_conti=num_cont_hb(i)
        num_conti1=num_cont_hb(i+1)
        do jj=1,num_conti
          j=jcont_hb(jj,i)
          do kk=1,num_conti1
            j1=jcont_hb(kk,i1)
c            write (iout,*) 'i=',i,' j=',j,' i1=',i1,' j1=',j1,
c     &         ' jj=',jj,' kk=',kk
            if (j1.eq.j+1 .or. j1.eq.j-1) then
C
C Contacts I-J and (I+1)-(J+1) or (I+1)-(J-1) occur simultaneously. 
C The system gains extra energy.
C Tentative expression & coefficients; assumed d(stacking)=4.5 A,
C parallel dipoles of stacknig bases and sin(mui)sin(muj)/eps/d^3=0.7
C Need to implement full formulas 34 and 35 from Liwo et al., 1998.
C
              ecorr=ecorr+ehbcorr(i,j,i+1,j1,jj,kk,0.528D0,0.132D0,
     &          gradcorr(1,1),gradxorr(1,1))
              if (energy_dec) write (iout,'(a6,2i5,0pf7.3)')
     &            'ecorrh',i,j,ehbcorr(i,j,i+1,j1,jj,kk,0.528D0,0.132D0,
     &          gradcorr(1,1),gradxorr(1,1))
              n_corr=n_corr+1
            else if (j1.eq.j) then
C
C Contacts I-J and I-(J+1) occur simultaneously. 
C The system loses extra energy.
C Tentative expression & coefficients; assumed d(stacking)=4.5 A,
C parallel dipoles of stacknig bases and sin(mui)sin(muj)/eps/d^3=0.7
C Need to implement full formulas 32 from Liwo et al., 1998.
C
c              write (iout,*) 'ecorr3: i=',i,' j=',j,' i1=',i1,' j1=',j1,
c     &         ' jj=',jj,' kk=',kk
              ecorr3=ecorr3+ehbcorr(i,j,i+1,j,jj,kk,0.310D0,-0.155D0,
     &          gradcorr3(1,1),gradxorr3(1,1))
            endif
          enddo ! kk
          do kk=1,num_conti
            j1=jcont_hb(kk,i)
c            write (iout,*) 'ecorr3: i=',i,' j=',j,' i1=',i1,' j1=',j1,
c     &         ' jj=',jj,' kk=',kk
            if (j1.eq.j+1) then
C Contacts I-J and (I+1)-J occur simultaneously. 
C The system loses extra energy.
              ecorr3=ecorr3+ehbcorr(i,j,i,j+1,jj,kk,0.310D0,-0.155D0,
     &           gradcorr3(1,1),gradxorr3(1,1))
            endif ! j1==j+1
          enddo ! kk
        enddo ! jj
      enddo ! i
      return
      end
c------------------------------------------------------------------------------
      double precision function ehbcorr(i,j,k,l,jj,kk,coeffp,coeffm,
     &  gradcorr,gradxorr)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      double precision gradcorr(3,maxres),gradxorr(3,maxres)
      double precision gx(3),gx1(3)
      logical lprn
      lprn=.false.
      eij=facont_hb(jj,i)
      ekl=facont_hb(kk,k)
      ees0pij=ees0p(jj,i)
      ees0pkl=ees0p(kk,k)
      ees0mij=ees0m(jj,i)
      ees0mkl=ees0m(kk,k)
      ekont=eij*ekl
      ees=-(coeffp*ees0pij*ees0pkl+coeffm*ees0mij*ees0mkl)
cd    ees=-(coeffp*ees0pkl+coeffm*ees0mkl)
C Following 4 lines for diagnostics.
cd    ees0pkl=0.0D0
cd    ees0pij=1.0D0
cd    ees0mkl=0.0D0
cd    ees0mij=1.0D0
cd      write (iout,*)'Contacts have occurred for nucleic bases',
cd     &  i,j,' fcont:',eij,' eij',' eesij',ees0pij,ees0mij,' and ',k,l
cd     & ,' fcont ',ekl,' eeskl',ees0pkl,ees0mkl,' ees=',ees
C Calculate the multi-body contribution to energy.
      ecorr=ecorr+ekont*ees
C Calculate multi-body contributions to the gradient.
      coeffpees0pij=coeffp*ees0pij
      coeffmees0mij=coeffm*ees0mij
      coeffpees0pkl=coeffp*ees0pkl
      coeffmees0mkl=coeffm*ees0mkl
      do ll=1,3
        gradxorr(ll,i)=gradxorr(ll,i)
     &  -ekont*(coeffpees0pkl*gacontp_hb1(ll,jj,i)+
     &  coeffmees0mkl*gacontm_hb1(ll,jj,i))
        gradxorr(ll,j)=gradxorr(ll,j)
     &  -ekont*(coeffpees0pkl*gacontp_hb2(ll,jj,i)+
     &  coeffmees0mkl*gacontm_hb2(ll,jj,i))
        gradxorr(ll,k)=gradxorr(ll,k)
     &  -ekont*(coeffpees0pij*gacontp_hb1(ll,kk,k)+
     &  coeffmees0mij*gacontm_hb1(ll,kk,k))
        gradxorr(ll,l)=gradxorr(ll,l)
     &  -ekont*(coeffpees0pij*gacontp_hb2(ll,kk,k)+
     &  coeffmees0mij*gacontm_hb2(ll,kk,k))
        gradlongij=ees*ekl*gacont_hbr(ll,jj,i)-
     &     ekont*(coeffpees0pkl*gacontp_hb3(ll,jj,i)+
     &     coeffmees0mkl*gacontm_hb3(ll,jj,i))
        gradcorr(ll,j)=gradcorr(ll,j)+gradlongij
        gradcorr(ll,i)=gradcorr(ll,i)-gradlongij
        gradlongkl=ees*eij*gacont_hbr(ll,kk,k)-
     &     ekont*(coeffpees0pij*gacontp_hb3(ll,kk,k)+
     &     coeffmees0mij*gacontm_hb3(ll,kk,k))
        gradcorr(ll,l)=gradcorr(ll,l)+gradlongkl
        gradcorr(ll,k)=gradcorr(ll,k)-gradlongkl
        gradxorr(ll,i)=gradxorr(ll,i)-gradlongij
        gradxorr(ll,j)=gradxorr(ll,j)+gradlongij
        gradxorr(ll,k)=gradxorr(ll,k)-gradlongkl
        gradxorr(ll,l)=gradxorr(ll,l)+gradlongkl
      enddo
      ehbcorr=ekont*ees
      return
      end
C-----------------------------------------------------------------------------
      double precision function scalar(u,v)
!DIR$ INLINEALWAYS scalar
#ifndef OSF
cDEC$ ATTRIBUTES FORCEINLINE::scalar
#endif
      implicit none
      double precision u(3),v(3)
cd      double precision sc
cd      integer i
cd      sc=0.0d0
cd      do i=1,3
cd        sc=sc+u(i)*v(i)
cd      enddo
cd      scalar=sc

      scalar=u(1)*v(1)+u(2)*v(2)+u(3)*v(3)
      return
      end
crc-------------------------------------------------
      SUBROUTINE MATVEC2(A1,V1,V2)
!DIR$ INLINEALWAYS MATVEC2
#ifndef OSF
cDEC$ ATTRIBUTES FORCEINLINE::MATVEC2
#endif
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      DIMENSION A1(2,2),V1(2),V2(2)
c      DO 1 I=1,2
c        VI=0.0
c        DO 3 K=1,2
c    3     VI=VI+A1(I,K)*V1(K)
c        Vaux(I)=VI
c    1 CONTINUE

      vaux1=a1(1,1)*v1(1)+a1(1,2)*v1(2)
      vaux2=a1(2,1)*v1(1)+a1(2,2)*v1(2)

      v2(1)=vaux1
      v2(2)=vaux2
      END
C---------------------------------------
      SUBROUTINE MATMAT2(A1,A2,A3)
#ifndef OSF
cDEC$ ATTRIBUTES FORCEINLINE::MATMAT2  
#endif
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      DIMENSION A1(2,2),A2(2,2),A3(2,2)
c      DIMENSION AI3(2,2)
c        DO  J=1,2
c          A3IJ=0.0
c          DO K=1,2
c           A3IJ=A3IJ+A1(I,K)*A2(K,J)
c          enddo
c          A3(I,J)=A3IJ
c       enddo
c      enddo

      ai3_11=a1(1,1)*a2(1,1)+a1(1,2)*a2(2,1)
      ai3_12=a1(1,1)*a2(1,2)+a1(1,2)*a2(2,2)
      ai3_21=a1(2,1)*a2(1,1)+a1(2,2)*a2(2,1)
      ai3_22=a1(2,1)*a2(1,2)+a1(2,2)*a2(2,2)

      A3(1,1)=AI3_11
      A3(2,1)=AI3_21
      A3(1,2)=AI3_12
      A3(2,2)=AI3_22
      END

c-------------------------------------------------------------------------
      double precision function scalar2(u,v)
!DIR$ INLINEALWAYS scalar2
      implicit none
      double precision u(2),v(2)
      double precision sc
      integer i
      scalar2=u(1)*v(1)+u(2)*v(2)
      return
      end

C-----------------------------------------------------------------------------

      subroutine transpose2(a,at)
!DIR$ INLINEALWAYS transpose2
#ifndef OSF
cDEC$ ATTRIBUTES FORCEINLINE::transpose2
#endif
      implicit none
      double precision a(2,2),at(2,2)
      at(1,1)=a(1,1)
      at(1,2)=a(2,1)
      at(2,1)=a(1,2)
      at(2,2)=a(2,2)
      return
      end
c--------------------------------------------------------------------------
      subroutine transpose(n,a,at)
      implicit none
      integer n,i,j
      double precision a(n,n),at(n,n)
      do i=1,n
        do j=1,n
          at(j,i)=a(i,j)
        enddo
      enddo
      return
      end
C---------------------------------------------------------------------------
      subroutine prodmat3(a1,a2,kk,transp,prod)
!DIR$ INLINEALWAYS prodmat3
#ifndef OSF
cDEC$ ATTRIBUTES FORCEINLINE::prodmat3
#endif
      implicit none
      integer i,j
      double precision a1(2,2),a2(2,2),a2t(2,2),kk(2,2),prod(2,2)
      logical transp
crc      double precision auxmat(2,2),prod_(2,2)

      if (transp) then
crc        call transpose2(kk(1,1),auxmat(1,1))
crc        call matmat2(a1(1,1),auxmat(1,1),auxmat(1,1))
crc        call matmat2(auxmat(1,1),a2(1,1),prod_(1,1)) 
        
           prod(1,1)=(a1(1,1)*kk(1,1)+a1(1,2)*kk(1,2))*a2(1,1)
     & +(a1(1,1)*kk(2,1)+a1(1,2)*kk(2,2))*a2(2,1)
           prod(1,2)=(a1(1,1)*kk(1,1)+a1(1,2)*kk(1,2))*a2(1,2)
     & +(a1(1,1)*kk(2,1)+a1(1,2)*kk(2,2))*a2(2,2)
           prod(2,1)=(a1(2,1)*kk(1,1)+a1(2,2)*kk(1,2))*a2(1,1)
     & +(a1(2,1)*kk(2,1)+a1(2,2)*kk(2,2))*a2(2,1)
           prod(2,2)=(a1(2,1)*kk(1,1)+a1(2,2)*kk(1,2))*a2(1,2)
     & +(a1(2,1)*kk(2,1)+a1(2,2)*kk(2,2))*a2(2,2)

      else
crc        call matmat2(a1(1,1),kk(1,1),auxmat(1,1))
crc        call matmat2(auxmat(1,1),a2(1,1),prod_(1,1))

           prod(1,1)=(a1(1,1)*kk(1,1)+a1(1,2)*kk(2,1))*a2(1,1)
     &  +(a1(1,1)*kk(1,2)+a1(1,2)*kk(2,2))*a2(2,1)
           prod(1,2)=(a1(1,1)*kk(1,1)+a1(1,2)*kk(2,1))*a2(1,2)
     &  +(a1(1,1)*kk(1,2)+a1(1,2)*kk(2,2))*a2(2,2)
           prod(2,1)=(a1(2,1)*kk(1,1)+a1(2,2)*kk(2,1))*a2(1,1)
     &  +(a1(2,1)*kk(1,2)+a1(2,2)*kk(2,2))*a2(2,1)
           prod(2,2)=(a1(2,1)*kk(1,1)+a1(2,2)*kk(2,1))*a2(1,2)
     &  +(a1(2,1)*kk(1,2)+a1(2,2)*kk(2,2))*a2(2,2)

      endif
c      call transpose2(a2(1,1),a2t(1,1))

crc      print *,transp
crc      print *,((prod_(i,j),i=1,2),j=1,2)
crc      print *,((prod(i,j),i=1,2),j=1,2)

      return
      end
