      subroutine readpdb
C Read the PDB file and convert the peptide geometry into virtual-chain 
C geometry.
      implicit none
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.CONTROL'
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.NAMES'
      character*3 seq,atom,res
      character*80 card
      double precision sccor(3,20),ccc(3)
      integer i,j,k,iii,ibeg,ishift,ishift1,ity,ires,ires_old,isugar
      integer sugarcode
      character*1 sugar
      double precision dcj
      integer rescode
      ibeg=1
      ishift1=0
      do 
        read (ipdbin,'(a80)',end=10) card
        if (card(:3).eq.'END') then
          goto 10
        else if (card(:3).eq.'TER') then
C End current chain
          ires_old=ires+1
          itype(ires_old)=ntyp1
          istype(ires_old)=isugar
          ibeg=2
c          write (iout,*) "Chain ended",ires,ishift,ires_old
          if (unres_pdb) then
            do j=1,3
              dc(j,ires)=sccor(j,iii)
            enddo
          else
            call sccenter(ires,iii,sccor)
            do j=1,3
              c(j,ires)=c(j,ires)/5
            enddo
          endif
        endif
C Fish out the ATOM cards.
        if (index(card(1:4),'ATOM').gt.0) then  
          read (card(14:16),'(a3)') atom
          if (atom.eq."C5'") then
C Calculate the CM of the preceding residue.
            if (ibeg.eq.0) then
              if (unres_pdb) then
                do j=1,3
                  dc(j,ires)=sccor(j,iii)
                enddo
              else
                call sccenter(ires,iii,sccor)
                do j=1,3
                  c(j,ires)=c(j,ires)/5
                enddo
              endif
            endif
C Start new residue.
            read (card(24:26),*) ires
            read (card(20:20),'(a1)') res(1:1)
            read (card(19:19),'(a1)') sugar
            isugar=sugarcode(sugar,ires)
c            write (2,*) "res",res," ires",ires," sugar ",sugar,
c     &         " isugar",isugar
            res(2:3)="  "
            if (ibeg.eq.1) then
              ishift=ires-2
              itype(1)=ntyp1
              istype(1)=isugar
              do k=1,3
                c(k,1)=0.0d0
              enddo
              ibeg=0          
            else if (ibeg.eq.2) then
c Start a new chain
              ishift=-ires_old+ires-1
c              write (iout,*) "New chain started",ires,ishift
              ibeg=0
            endif
            ires=ires-ishift
            itype(ires)=rescode(ires,res,0)
            istype(ires)=isugar
            read(card(31:54),'(3f8.3)') (sccor(j,1),j=1,3)
            do j=1,3
              c(j,ires)=0.0d0
            enddo
c            write (iout,'(2i3,2x,a,3f8.3)') 
c     &       ires,itype(ires),res,(c(j,ires),j=1,3)
            iii=1
            do j=1,3
              c(j,ires)=c(j,ires)/5
            enddo
          else if (atom.ne.'P  '.and.atom(1:1).ne.'H' .and. 
     &             atom.ne.'OP1' .and. atom.ne.'OP2 ' .and. 
     &             atom(3:3).ne."'") then
            iii=iii+1
            read(card(31:54),'(3f8.3)') (sccor(j,iii),j=1,3)
          else if (atom.eq."C1'" .or. atom.eq."C2'" .or. atom.eq."C3'"
     &          .or. atom.eq."C4'" .or. atom.eq."O4'") then
            read(card(31:54),'(3f8.3)') (ccc(j),j=1,3)
c            write (2,'(i5,3f10.5)') ires,(ccc(j),j=1,3)
            do j=1,3
              c(j,ires)=c(j,ires)+ccc(j)
            enddo
          endif
        endif
      enddo
   10 continue
C Calculate the CM of the last side chain.
      if (unres_pdb) then
        do j=1,3
          dc(j,ires)=sccor(j,iii)
        enddo
      else 
        call sccenter(ires,iii,sccor)
      endif
c      do i=nnt,nct
c        write (iout,'(2i3,2x,a,2x,3f8.3,5x,3f8.3)')
c     &    i,itype(i),restyp(itype(i)),(c(j,i),j=1,3),
c     &    (c(j,i+nres),j=1,3)
c      enddo
      nres=ires+1
      nsup=nres-2
      nstart_sup=2
      write (iout,*) "From PDB file: NRES",nres," NSUP",NSUP,
     & " NSTART_SUP",nstart_sup
      itype(nres)=ntyp1
      istype(nres)=istype(nres-1)
      if (unres_pdb) then
        c(1,nres)=c(1,nres-1)+6.4d0
        c(2,nres)=c(2,nres-1)
        c(3,nres)=c(3,nres-1)
      else
        do j=1,3
          dcj=c(j,nres-2)-c(j,nres-3)
          c(j,nres)=c(j,nres-1)+dcj
          c(j,2*nres)=c(j,nres)
        enddo
      endif
      do i=2,nres-1
        do j=1,3
          c(j,i+nres)=dc(j,i)
        enddo
      enddo
      do j=1,3
        c(j,nres+1)=c(j,1)
        c(j,2*nres)=c(j,nres)
      enddo
      if (unres_pdb) then
        c(1,1)=c(1,2)-6.4d0
        c(2,1)=c(2,2)
        c(3,1)=c(3,2)
      else
        do j=1,3
          dcj=c(j,4)-c(j,3)
          c(j,1)=c(j,2)-dcj
          c(j,nres+1)=c(j,1)
        enddo
      endif
      do i=2,nres-1
c        write (iout,*) i,itype(i)
        if (itype(i).eq.ntyp1) then
c          write (iout,*) "dummy",i,itype(i)
          do j=1,3
            c(j,i)=((c(j,i-1)+c(j,i+1))/2+2*c(j,i-1)-c(j,i-2))/2
          enddo
        endif
      enddo
C Calculate internal coordinates.
c      do ires=1,nres
c       write (iout,'(2i3,2x,a,i5,3f8.3,5x,3f8.3)') 
c     &   ires,itype(ires),restyp(itype(ires)),istype(ires),
c     &   (c(j,ires),j=1,3),(c(j,nres+ires),j=1,3)
c      enddo
      call int_from_cart(.true.,.false.)
      do i=1,nres-1
        do j=1,3
          dc(j,i)=c(j,i+1)-c(j,i)
          dc_norm(j,i)=dc(j,i)*vbld_inv(i+1)
        enddo
      enddo
      do i=2,nres-1
        do j=1,3
          dc(j,i+nres)=c(j,i+nres)-c(j,i)
          dc_norm(j,i+nres)=dc(j,i+nres)*vbld_inv(i+nres)
        enddo
c        write (iout,*) i,(dc(j,i+nres),j=1,3),(dc_norm(j,i+nres),j=1,3),
c     &   vbld_inv(i+nres)
      enddo
c      call chainbuild
C Copy the coordinates to reference coordinates
      do i=1,2*nres
        do j=1,3
          cref(j,i)=c(j,i)
        enddo
      enddo
      do i=1,nres
        phi_ref(i)=phi(i)
        theta_ref(i)=theta(i)
        alph_ref(i)=alph(i)
        omeg_ref(i)=omeg(i)
      enddo
      ishift_pdb=ishift
      return
      end
c---------------------------------------------------------------------------
      subroutine int_from_cart(lside,lprn)
      implicit none
      include 'DIMENSIONS'
      include 'DIMENSIONS.ZSCOPT'
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.NAMES'
      character*3 seq,atom,res
      character*80 card
      double precision sccor(3,20)
      integer rescode
      double precision dist,alpha,beta,di
      integer i,j,iti
      logical lside,lprn
      if (lprn) then 
        write (iout,'(/a)') 
     &  'Internal coordinates calculated from crystal structure.'
        if (lside) then 
          write (iout,'(8a)') '  Res  ','       dvb','     Theta',
     & '       Phi','    Dsc_id','       Dsc','     Alpha',
     & '     Omega'
        else 
          write (iout,'(4a)') '  Res  ','       dvb','     Theta',
     & '       Phi'
        endif
      endif
      do i=2,nres
        iti=itype(i)
c        write (iout,*) i,i-1,(c(j,i),j=1,3),(c(j,i-1),j=1,3),dist(i,i-1)
        if (itype(i-1).ne.ntyp1 .and. itype(i).ne.ntyp1 .and.
     &    (dist(i,i-1).lt.2.0D0 .or. dist(i,i-1).gt.12.0D0)) then
          write (iout,'(a,i4)') 'Bad Cartesians for residue',i
          stop
        endif
        theta(i+1)=alpha(i-1,i,i+1)
        if (i.gt.2) phi(i+1)=beta(i-2,i-1,i,i+1)
      enddo
      if (itype(1).eq.21) then
        do j=1,3
          c(j,1)=c(j,2)+(c(j,3)-c(j,4))
        enddo
      endif
      if (itype(nres).eq.21) then
        do j=1,3
          c(j,nres)=c(j,nres-1)+(c(j,nres-2)-c(j,nres-3))
        enddo
      endif
      if (lside) then
        do i=2,nres-1
          do j=1,3
            c(j,maxres2)=0.5D0*(c(j,i-1)+c(j,i+1))
          enddo
          iti=itype(i)
          di=dist(i,nres+i)
          if (iti.ne.10) then
            alph(i)=alpha(nres+i,i,maxres2)
            omeg(i)=beta(nres+i,i,maxres2,i+1)
          endif
          if (lprn)
     &    write (iout,'(a3,i4,7f10.3)') restyp(iti),i,dist(i,i-1),
     &    rad2deg*theta(i),rad2deg*phi(i),dsc(iti),di,
     &    rad2deg*alph(i),rad2deg*omeg(i)
        enddo
      else if (lprn) then
        do i=2,nres
          iti=itype(i)
          write (iout,'(a3,i4,7f10.3)') restyp(iti),i,dist(i,i-1),
     &    rad2deg*theta(i),rad2deg*phi(i)
        enddo
      endif
      return
      end
c---------------------------------------------------------------------------
      subroutine sccenter(ires,nscat,sccor)
      implicit none
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      integer ires,nscat,i,j
      double precision sccor(3,20),sccmj
      do j=1,3
        sccmj=0.0D0
        do i=1,nscat
          sccmj=sccmj+sccor(j,i) 
        enddo
        dc(j,ires)=sccmj/nscat
      enddo
      return
      end
c---------------------------------------------------------------------------
      subroutine bond_regular
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CALC'
      include 'COMMON.INTERACT'
      include 'COMMON.CHAIN'
      do i=1,nres-1
       vbld(i+1)=vbl
       vbld_inv(i+1)=1.0d0/vbld(i+1)
       vbld(i+1+nres)=dsc(itype(i+1))
       vbld_inv(i+1+nres)=dsc_inv(itype(i+1))
c       print *,vbld(i+1),vbld(i+1+nres)
      enddo
      return
      end
