      subroutine pair_anal(iii)
c
c A naive subroutine to find the number of same-chain (hairpin) and
c across-strand paired bases.
c
      implicit none
      include "DIMENSIONS"
      include "DIMENSIONS.ZSCOPT"
      include "DIMENSIONS.FREE"
#ifdef MPI
      include "mpif.h"
      integer IERROR,ERRCODE,STATUS(MPI_STATUS_SIZE)
      include "COMMON.MPI"
#endif
      include "COMMON.CHAIN"
      include "COMMON.IOUNITS"
      include "COMMON.PROTFILES"
      include "COMMON.NAMES"
      include "COMMON.VAR"
      include "COMMON.SBRIDGE"
      include "COMMON.GEO"
      include "COMMON.FFIELD"
      include "COMMON.ENEPS"
      include "COMMON.LOCAL"
      include "COMMON.WEIGHTS"
      include "COMMON.INTERACT"
      include "COMMON.FREE"
      include "COMMON.ENERGIES"
      include "COMMON.CONTROL"
      include "COMMON.TORCNSTR"
      include "COMMON.ALLPARM"
      include "COMMON.GUAN"
      integer ii,iii
      integer i,j,nn,ibreak,npair_har,npair_inter,nstr,nstran(2),jmin,
     &  nn2,nn2h,nocc(maxres),iocc(20,maxres)
      real*4 docc(20,maxres)
      integer isep /4/
      double precision fac /2.24492409661874596284d0/ ! 2*2.^(1./6.)
      double precision dmin,dd,dist
c      write(iout,*) "Enter PAIR_ANAL iii",iii
      nn=0
      npair_har=0
      npair_inter=0 
      nstr=1
      nstran(1)=0 
      do i=1,nres
        nocc(i)=0
      enddo
      ii = 0
      do i=nnt,nct
        if (itype(i).lt.ntyp1) then
          nn=nn+1
          nstran(nstr)=nstran(nstr)+1 
        else 
          nstr=nstr+1
          cycle
        endif
        dmin=1.0d10
        jmin=nres
        do j=i+2,nct
          if ((ibreak(i,j).gt.0 .or. j-i.ge.isep) .and.
     &      itype(j).lt.ntyp1) then
            dd=dist(nres+i,nres+j)
            if (dd.lt.dmin) dmin=dd
            if (dd.lt.fac*sigma(itype(i),itype(j))) then
              nocc(i)=nocc(i)+1
              iocc(nocc(i),i)=j
              nocc(j)=nocc(j)+1
              iocc(nocc(j),j)=i 
              docc(nocc(i),i)=dd
              docc(nocc(j),j)=dd
            endif
          endif
        enddo
        if (itype(i).eq.2) then
          ii = ii + 1
          d_guan(ii,iii) = dmin
        endif
      enddo
      do i=1,nguan
        iocc_guan(i,iii)=0
      enddo
      ii = 0
      do i=nnt,nct
        if (itype(i).eq.2) then
          ii = ii + 1
          if (nocc(i).gt.0) iocc_guan(ii,iii) = 1
        endif
      enddo 
#ifdef DEBUG
      write (iout,*) "Conformation",iii,
     &   " Neighbor list and neighbor distances before sort"
      do i=nnt,nct
        write (iout,'(2i5,5(i5,f10.5))') i,nocc(i),
     &             (iocc(j,i),docc(j,i),j=1,nocc(i))
      enddo
#endif
c Sort occupation table acc. to distance
      do i=nnt,nct
        call mysort1(nocc(i),docc(1,i),iocc(1,i))
      enddo
#ifdef DEBUG
      write (iout,*) "Conformation",iii,
     &   " Neighbor list and neighbor distances after sort"
      do i=nnt,nct
        write (iout,'(2i5,5(i5,f10.5))') i,nocc(i),
     &             (iocc(j,i),docc(j,i),j=1,nocc(i))
      enddo
#endif
      npair_inter=0
      npair_har=0
      do i=nnt,nct
        if (nocc(i).gt.0) npair_har=npair_har+1
        do j=1,nocc(i)
          if (ibreak(i,iocc(j,i)).eq.1) then
            npair_inter=npair_inter+1
            npair_har=npair_har-1
            exit
          endif 
        enddo
c        write (iout,*) "npair_inter",npair_inter," npair_har",npair_har
      enddo
      nn2h=0
      do i=1,nstr
        nn2h=nn2h+max0((nstran(i)-isep)/2,0)
      enddo 
      q(nQ+3,iii)=npair_inter/(nn+0.0d0)
      q(nQ+4,iii)=npair_har/(nn2h+0.0d0)
      if (npair_inter.gt.0) then
        q(nQ+5,iii)=1.0d0
      else
        q(nQ+5,iii)=0.0d0
      endif
#ifdef DEBUG
      write (iout,*) "nn",nn," npair_inter",npair_inter,
     &   " npair_har",npair_har
      write (iout,*) "p_inter",q(nQ+3,iii)," p_hairpin",q(nQ+4,iii),
     &   " paired",q(nQ+5,iii)," rmsd",q(nQ+1,iii)
#endif
      return
      end
c------------------------------------------------------------------------------------------------------
      integer function ibreak(i,j)
c
c Determine if residues i and j belong to same strand (0) or separate strands (1)
c
      implicit none
      include "DIMENSIONS"
      include "COMMON.CHAIN"
      include "COMMON.IOUNITS"
      include "COMMON.INTERACT"
      integer i,j,k,ii,jj
      if (j.gt.i) then
        ii=i
        jj=j
      else
        ii=j
        jj=i
      endif
      do k=ii+1,jj
        if (itype(k).eq.ntyp1) then 
          ibreak=1
          return
        endif
      enddo
      ibreak=0
      return
      end
